{===========================================================================}
{ Wiggly Worm '94 Special Edition by J.P.Boggis                             }
{===========================================================================}
{ Interrupt include file.                                                   }
{---------------------------------------------------------------------------}
{ This program is free software; you can redistribute it and/or modify it   }
{ under the terms of the GNU General Public License as published by the     }
{ Free Software Foundation; either version 2 of the License, or (at your    }
{ option) any later version.                                                }
{                                                                           }
{ This program is distributed in the hope that it will be useful, but       }
{ WITHOUT ANY WARRANTY; without even the implied warranty of                }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         }
{ General Public License for more details.                                  }
{                                                                           }
{ You should have received a copy of the GNU General Public License along   }
{ with this program; if not, write to the Free Software Foundation, Inc.,   }
{ 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                   }
{---------------------------------------------------------------------------}
{ Started by J.P.Boggis (AKA JC Digita) on 07/10/1993.                      }
{                                                                           }
{    Release 2.0  -  24/01/1994                                             }
{    Release 2.1  -  20/02/1994                                             }
{    Release 2.2  -  22/02/1994                                             }
{    Release 2.3  -  23/02/1994                                             }
{    Release 2.4  -  05/04/1994                                             }
{    Release 2.5  -  27/12/2000  -  Special Edition                         }
{===========================================================================}
{ email@jcdigita.com                                       www.jcdigita.com }
{===========================================================================}


{$F+}


{Timer interrupt routine to handle sound and game timing}
procedure time_handler;
begin
     {***  Clear keyboard buffer  ***}
     if not buffer then mem[$0040:$001A]:=mem[$0040:$001C];

     {***  Worm head colour cycle  ***}
     asm
        inc INTEGER PTR headcycle
     end;

     {***  Sound queue handling  ***}
     if not adding then
     begin
          if (ticks=0) then
          begin
               if qpos<=qlen then
               begin
                    if (soundq[qpos].pitch<>0) and snd then sound(soundq[qpos].pitch) else
                       nosound;
                    ticks:=soundq[qpos].length;
                    inc(qpos);
                    if qpos>qlen then if not mrepeat then shutup:=true else qpos:=1;
               end else if shutup then
               begin
                    shutup:=false;
                    priority:=0;
                    nosound;
               end;
          end else dec(ticks);
     end;

     asm
        {***  Icon display handling  ***}
        mov  BX,0
        mov  CX,1
        cmp  BYTE PTR pause,0       {Paused?}
        jne  @sdcend
@iconlp:cmp  WORD PTR icon[BX+6],0  {HOWLONG = 0?}
        je   @icon0
        dec  WORD PTR icon[BX+6]    {HOWLONG}
        jmp  @icotst
 @icon0:mov  BYTE PTR icon[BX+4],1  {DOACTION}
@icotst:inc  CX
        mov  AX,WORD PTR maxicons
        cmp  CX,AX
        jg   @icoend
        add  BX,8
        jmp  @iconlp
@icoend:

        {***  Decrease Movement Points counter for each player  ***}
        cmp  WORD PTR mpointscount[0],0
        je   @mpt2
        dec  WORD PTR mpointscount[0]
  @mpt2:cmp  WORD PTR mpointscount[2],0
        je   @mpt3
        dec  WORD PTR mpointscount[2]
  @mpt3:cmp  WORD PTR mpointscount[4],0
        je   @mptend
        dec  WORD PTR mpointscount[4]
@mptend:

        {***  Decrease invinciblity counter for each player  ***}
        cmp  WORD PTR invcount[0],0
        je   @ict2
        dec  WORD PTR invcount[0]
  @ict2:cmp  WORD PTR invcount[2],0
        je   @ict3
        dec  WORD PTR invcount[2]
  @ict3:cmp  WORD PTR invcount[4],0
        je   @ictend
        dec  WORD PTR invcount[4]
@ictend:

        {***  Decrease worm eating counter for each player  ***}
        cmp  WORD PTR eatcount[0],0
        je   @eat2
        dec  WORD PTR eatcount[0]
  @eat2:cmp  WORD PTR eatcount[2],0
        je   @eat3
        dec  WORD PTR eatcount[2]
  @eat3:cmp  WORD PTR eatcount[4],0
        je   @eatend
        dec  WORD PTR eatcount[4]
@eatend:

        {***  Decrease Super Power counter for each player  ***}
        cmp  WORD PTR supercount[0],1
        jl   @sut2
        je   @sua2
        dec  WORD PTR supercount[0]
        jmp  @sut2
  @sua2:mov  WORD PTR speedupcount[0],0
        mov  WORD PTR slowdowncount[0],0
        mov  AX,WORD PTR speedstore[0]
        mov  WORD PTR speed[0],AX
        mov  WORD PTR supercount[0],0
        mov  BYTE PTR bufhead[0],1
        mov  BYTE PTR buftail[0],1
        mov  BYTE PTR wormmoving[0],0
  @sut2:cmp  WORD PTR supercount[2],1
        jl   @sut3
        je   @sua3
        dec  WORD PTR supercount[2]
        jmp  @sut3
  @sua3:mov  WORD PTR speedupcount[2],0
        mov  WORD PTR slowdowncount[2],0
        mov  AX,WORD PTR speedstore[2]
        mov  WORD PTR speed[2],AX
        mov  WORD PTR supercount[2],0
        mov  BYTE PTR bufhead[1],1
        mov  BYTE PTR buftail[1],1
        mov  BYTE PTR wormmoving[1],0
  @sut3:cmp  WORD PTR supercount[4],1
        jl   @sutend
        je   @suaend
        dec  WORD PTR supercount[4]
        jmp  @sutend
@suaend:mov  WORD PTR speedupcount[4],0
        mov  WORD PTR slowdowncount[4],0
        mov  AX,WORD PTR speedstore[4]
        mov  WORD PTR speed[4],AX
        mov  WORD PTR supercount[4],0
        mov  BYTE PTR bufhead[2],1
        mov  BYTE PTR buftail[2],1
        mov  BYTE PTR wormmoving[2],0
@sutend:

        {***  Decrease zero POWERCOL counter for each player  ***}
        cmp  WORD PTR zeropowercol[0],0
        jg   @za1
        mov  BYTE PTR powercol[0],0
        jmp  @zpcol2
   @za1:dec  WORD PTR zeropowercol[0]
@zpcol2:cmp  WORD PTR zeropowercol[2],0
        jg   @za2
        mov  BYTE PTR powercol[1],0
        jmp  @zpcol3
   @za2:dec  WORD PTR zeropowercol[2]
@zpcol3:cmp  WORD PTR zeropowercol[4],0
        jg   @za3
        mov  BYTE PTR powercol[2],0
        jmp  @zpend
   @za3:dec  WORD PTR zeropowercol[4]
 @zpend:

        {***  Decrease Stun counter for each player  ***}
        cmp  WORD PTR stuncount[0],1
        jl   @sct2
        jg   @dsct1
        mov  BYTE PTR wormmoving[0],1
 @dsct1:dec  WORD PTR stuncount[0]
  @sct2:cmp  WORD PTR stuncount[2],1
        jl   @sct3
        jg   @dsct2
        mov  BYTE PTR wormmoving[1],1
 @dsct2:dec  WORD PTR stuncount[2]
  @sct3:cmp  WORD PTR stuncount[4],1
        jl   @sctend
        jg   @dsct3
        mov  BYTE PTR wormmoving[2],1
 @dsct3:dec  WORD PTR stuncount[4]
@sctend:

        {***  Decrease Speed Up counter for each player  ***}
        cmp  WORD PTR speedupcount[0],1
        jl   @suc2
        jg   @dsuc1
        add  WORD PTR speed[0],5
 @dsuc1:dec  WORD PTR speedupcount[0]
  @suc2:cmp  WORD PTR speedupcount[2],1
        jl   @suc3
        jg   @dsuc2
        add  WORD PTR speed[2],5
 @dsuc2:dec  WORD PTR speedupcount[2]
  @suc3:cmp  WORD PTR speedupcount[4],1
        jl   @sucend
        jg   @dsuc3
        add  WORD PTR speed[4],5
 @dsuc3:dec  WORD PTR speedupcount[4]
@sucend:

        {***  Decrease Slow Down counter for each player  ***}
        cmp  WORD PTR slowdowncount[0],1
        jl   @sdc2
        jg   @dsdc1
        sub  WORD PTR speed[0],5
 @dsdc1:dec  WORD PTR slowdowncount[0]
  @sdc2:cmp  WORD PTR slowdowncount[2],1
        jl   @sdc3
        jg   @dsdc2
        sub  WORD PTR speed[2],5
 @dsdc2:dec  WORD PTR slowdowncount[2]
  @sdc3:cmp  WORD PTR slowdowncount[4],1
        jl   @sdcend
        jg   @dsdc3
        sub  WORD PTR speed[4],5
 @dsdc3:dec  WORD PTR slowdowncount[4]
@sdcend:

        {***  Decrease DEL (Timing variable)  ***}
        cmp  WORD PTR del,0
        je   @del0
        dec  WORD PTR del
  @del0:
     end;
end;

{Add key press (Direction of) to key press buffer}
procedure buffer_add; assembler;
asm
    {***  Put key press into key press buffer  ***}
    mov BX,WORD PTR kplayer
    dec BX
    mov CX,keybuffersize
    mov AX,BX
    mul CX
    add AL,BYTE PTR bufhead[BX]
    dec AX
    mov BX,AX
    mov AX,WORD PTR kdir
    mov BYTE PTR keybuffer[BX],AL
    {***  Move head pointer on one  ***}
    mov BX,WORD PTR kplayer
    dec BX
    mov DL,BYTE PTR bufhead[BX]
    inc DL
    cmp DL,keybuffersize
    jle @L1
    mov DL,1
    {***  Move tail pointer on one if head = position of tail  ***}
@L1:mov DH,BYTE PTR buftail[BX]
    cmp DL,DH
    jne @LE
    inc DH
    cmp DH,keybuffersize
    jle @L2
    mov DH,2
@L2:mov BYTE PTR buftail[BX],DH
@LE:mov BYTE PTR bufhead[BX],DL
end;

{Keyboard interrupt routine to handle keyboard control during game}
procedure keyb_handler; assembler;
asm
    in  AL,60h
    cmp AL,BYTE PTR oval
    je  @END
    mov BYTE PTR oval,AL
    cmp AL,1
    jne @P1U
    mov BYTE PTR escape,1
    jmp @END

     {***  Player 1 pressed up?  ***}
@P1U:cmp AL,33
     jne @P2U
     mov WORD PTR kplayer,1
     mov WORD PTR kdir,1
     call buffer_add
     jmp @PR1

     {***  Player 2 pressed up?  ***}
@P2U:cmp AL,77
     jne @P3U
     mov WORD PTR kplayer,2
     mov WORD PTR kdir,1
     call buffer_add
     jmp @PR2

     {***  Player 3 pressed up?  ***}
@P3U:cmp AL,11
     jne @P1R
     mov WORD PTR kplayer,3
     mov WORD PTR kdir,1
     call buffer_add
     jmp @PR3

     {***  Player 1 pressed right?  ***}
@P1R:cmp AL,45
     jne @P2R
     mov WORD PTR kplayer,1
     mov WORD PTR kdir,2
     call buffer_add
     jmp @PR1

     {***  Player 2 pressed right?  ***}
@P2R:cmp AL,80
     jne @P3R
     mov WORD PTR kplayer,2
     mov WORD PTR kdir,2
     call buffer_add
     jmp @PR2

     {***  Player 3 pressed right?  ***}
@P3R:cmp AL,23
     jne @P1D
     mov WORD PTR kplayer,3
     mov WORD PTR kdir,2
     call buffer_add
     jmp @PR3

     {***  Player 1 pressed down?  ***}
@P1D:cmp AL,46
     jne @P2D
     mov WORD PTR kplayer,1
     mov WORD PTR kdir,3
     call buffer_add
     jmp @PR1

     {***  Player 2 pressed down?  ***}
@P2D:cmp AL,81
     jne @P3D
     mov WORD PTR kplayer,2
     mov WORD PTR kdir,3
     call buffer_add
     jmp @PR2

     {***  Player 3 pressed down?  ***}
@P3D:cmp AL,24
     jne @P1L
     mov WORD PTR kplayer,3
     mov WORD PTR kdir,3
     call buffer_add
     jmp @PR3

     {***  Player 1 pressed left?  ***}
@P1L:cmp AL,44
     jne @P2L
     mov WORD PTR kplayer,1
     mov WORD PTR kdir,4
     call buffer_add
     jmp @PR1

     {***  Player 2 pressed left?  ***}
@P2L:cmp AL,79
     jne @P3L
     mov WORD PTR kplayer,2
     mov WORD PTR kdir,4
     call buffer_add
     jmp @PR2

     {***  Player 3 pressed left?  ***}
@P3L:cmp AL,22
     jne @P1F
     mov WORD PTR kplayer,3
     mov WORD PTR kdir,4
     call buffer_add
     jmp @PR3

     {***  Player 1 pressed fire?  ***}
@P1F:cmp AL,34
     jne @P2F
     mov BYTE PTR key[0],1
     cmp BYTE PTR wormmoving[0],1
     je  @PR1
     mov AL,BYTE PTR lastdir[0]
     mov BYTE PTR key[1],AL
     jmp @PR1

     {***  Player 2 pressed fire?  ***}
@P2F:cmp AL,78
     jne @P3F
     mov BYTE PTR key[2],1
     cmp BYTE PTR wormmoving[1],1
     je  @PR2
     mov AL,BYTE PTR lastdir[1]
     mov BYTE PTR key[3],AL
     jmp @PR2

     {***  Player 3 pressed fire?  ***}
@P3F:cmp AL,12
     jne @PAU
     mov BYTE PTR key[4],1
     cmp BYTE PTR wormmoving[2],1
     je  @PR3
     mov AL,BYTE PTR lastdir[2]
     mov BYTE PTR key[5],AL
     jmp @PR3

     {***  Pause game?  ***}
@PAU:cmp AL,57
     jne @SND
     mov BYTE PTR pause,1
     jmp @END

     {***  Toggle sound on/off?  ***}
@SND:cmp AL,59
     jne @BOS
     cmp BYTE PTR snd,0
     je  @SL1
     mov BYTE PTR snd,0
     jmp @END
@SL1:mov BYTE PTR snd,1
     jmp @END

     {***  Boss key?  ***}
@BOS:cmp AL,68
     jne @END
     mov BYTE PTR escape,1
     mov BYTE PTR boss,1

@PR1:mov BYTE PTR wormmoving[0],1  {Start worm moving if it isn't already}
     mov BYTE PTR pause,0          {Unpause game if it's paused          }
     jmp @end

@PR2:mov BYTE PTR wormmoving[1],1  {Start worm moving if it isn't already}
     mov BYTE PTR pause,0          {Unpause game if it's paused          }
     jmp @end

@PR3:mov BYTE PTR wormmoving[2],1  {Start worm moving if it isn't already}
     mov BYTE PTR pause,0          {Unpause game if it's paused          }
     jmp @end

     {*** Push flags and call old keyboard ISR  ***}
@END:pushf
     call old09
end;
{$F-}

{Play worm theme music}
procedure worm_theme;
begin
     addchord(196,781,true);
     addchord(196,781,false);
     addchord(238,781,false);
     addchord(250,781,false);
     addchord(196,781,false);
     addchord(196,587,false);
     addchord(238,660,false);
     addchord(250,623,false);
     addchord(196,587,false);
     addchord(196,587,false);
     addchord(238,587,false);
     addchord(250,587,false);
     addchord(196,587,false);
     addchord(196,587,false);
     addchord(238,660,false);
     addchord(250,587,false);
     addchord(220,880,false);
     addchord(220,880,false);
     addchord(262,880,false);
     addchord(278,880,false);
     addchord(220,880,false);
     addchord(220,660,false);
     addchord(262,740,false);
     addchord(278,697,false);
     addchord(220,660,false);
     addchord(220,660,false);
     addchord(262,660,false);
     addchord(278,660,false);
     addchord(220,660,false);
     addchord(220,660,false);
     addchord(262,740,false);
     addchord(278,660,false);
     addchord(147,1171,false);
     addchord(147,1171,false);
     addchord(175,1171,false);
     addchord(185,1171,false);
     addchord(147,1171,false);
     addchord(147,880,false);
     addchord(175,988,false);
     addchord(185,928,false);
     addchord(147,880,false);
     addchord(147,880,false);
     addchord(175,880,false);
     addchord(185,880,false);
     addchord(147,880,false);
     addchord(147,880,false);
     addchord(175,988,false);
     addchord(185,880,false);
     addchord(196,781,false);
     addchord(196,781,false);
     addchord(238,781,false);
     addchord(250,781,false);
     addchord(196,781,false);
     addchord(196,781,false);
     addchord(238,880,false);
     addchord(250,988,false);
     addchord(196,781,false);
     addchord(196,781,false);
     addchord(238,781,false);
     addchord(250,781,false);
     addchord(196,781,false);
     addchord(196,781,false);
     addchord(238,781,false);
     addchord(250,781,false);
     addchord(196,781,false);
     addchord(196,781,false);
     addchord(196,781,false);
     addchord(196,781,false);
end;