{===========================================================================}
{ KeyBiz Turbo Pascal Unit by J.P.Boggis                                    }
{===========================================================================}
{ Useful text commands.                                                     }
{                                                                           }
{ This unit was developed in 1992 using Borland Turbo Pascal 6.0, but is    }
{ known to work with Turbo Pascal 7.0 also.                                 }
{---------------------------------------------------------------------------}
{ This program is free software; you can redistribute it and/or modify it   }
{ under the terms of the GNU General Public License as published by the     }
{ Free Software Foundation; either version 2 of the License, or (at your    }
{ option) any later version.                                                }
{                                                                           }
{ This program is distributed in the hope that it will be useful, but       }
{ WITHOUT ANY WARRANTY; without even the implied warranty of                }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         }
{ General Public License for more details.                                  }
{                                                                           }
{ You should have received a copy of the GNU General Public License along   }
{ with this program; if not, write to the Free Software Foundation, Inc.,   }
{ 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                   }
{---------------------------------------------------------------------------}
{ Written - 27/01/1992                                                      }
{  Update - 12/05/1992                                                      }
{  Update - 02/06/1992                                                      }
{  Update - 20/02/1993                                                      }
{  Update - 21/07/1993                                                      }
{===========================================================================}
{ email@jcdigita.com                                       www.jcdigita.com }
{===========================================================================}


unit keybiz;

interface

const on=1;
      off=0;

      tchar:char=' ';  {Character used to pad out blanks in TRUNC_STR}

procedure curs(onoff:byte);
function  get_bit(wbyte:byte;wbitno:byte):boolean;
function  get_bitw(wword:word;wbitno:byte):boolean;
function  convert(number:longint):string;
function  trunc_str(tstr:string;tlength:byte):string;
function  upper(what:string):string;
function  lower(what:string):string;
procedure set_bit(var wbyte:byte;wbitno:byte;wstatus:boolean);
procedure set_bitw(var wword:word;wbitno:byte;wstatus:boolean);
procedure surround(bd,wx,wy,bgcol,fgcol,txcol:byte;what:string);
procedure centre(cttext:string);
procedure textcolour(bgcol,fgcol:byte);
procedure waitkey;
procedure buffer_write(bwstr:string;hzero:boolean);
procedure execute(command:string);
function  searchparam(param:string):boolean;
function  zero(number:longint;len:byte):string;
function  get_attr(cbg,cfg:byte):byte;

implementation

uses crt,dos,memory;

{Returns the status of the bit number WBITNO in the byte WBYTE}
function get_bit(wbyte:byte;wbitno:byte):boolean;
var test_bit,tloop:byte;
begin
     test_bit:=1;
     if wbitno<>0 then for tloop:=0 to pred(wbitno) do test_bit:=test_bit*2;
     if wbyte and test_bit<>0 then get_bit:=true else get_bit:=false;
end;

{Returns the status of the bit number WBITNO in the word WWORD}
function get_bitw(wword:word;wbitno:byte):boolean;
var test_bit:word;
    tloop:byte;

begin
     test_bit:=1;
     if wbitno<>0 then for tloop:=0 to pred(wbitno) do test_bit:=test_bit*2;
     if wword and test_bit<>0 then get_bitw:=true else get_bitw:=false;
end;

{Sets the bit WBITNO status to the status WSTATUS in the word WBYTE}
procedure set_bit(var wbyte:byte;wbitno:byte;wstatus:boolean);
var test_bit,tloop:byte;
begin
     test_bit:=1;
     if wbitno<>0 then for tloop:=0 to pred(wbitno) do test_bit:=test_bit*2;
     if wstatus then if wbyte and test_bit=0 then inc(wbyte,test_bit);
     if not wstatus then if wbyte and test_bit<>0 then dec(wbyte,test_bit);
end;

{Sets the bit WBITNO status to the status WSTATUS in the word WWORD}
procedure set_bitw(var wword:word;wbitno:byte;wstatus:boolean);
var test_bit:word;
    tloop:byte;

begin
     test_bit:=1;
     if wbitno<>0 then for tloop:=0 to pred(wbitno) do test_bit:=test_bit*2;
     if wstatus then if wword and test_bit=0 then inc(wword,test_bit);
     if not wstatus then if wword and test_bit<>0 then dec(wword,test_bit);
end;

{Converts a number into a string}
function convert(number:longint):string;
var temp_string:string;
begin
     str(number,temp_string);
     convert:=temp_string;
end;

{Truncate a string to length specified}
function trunc_str(tstr:string;tlength:byte):string;
begin
     if length(tstr)>tlength then
     begin
          tstr[0]:=char(tlength);
          if length(tstr)>2 then tstr[pred(length(tstr))]:=tchar;
          tstr[length(tstr)]:=#16;
     end else while length(tstr)<tlength do tstr:=tstr+tchar;
     trunc_str:=tstr;
end;

{Turn cursor on(1) or off(0)}
procedure curs(onoff:byte);
var regs:registers;
begin
     with regs do
     begin
          AH:=1;
          AL:=0;
          if onoff=1 then CH:=6 else if onoff=2 then CH:=1 else
             if onoff=0 then ch:=$20;
          CL:=7;
          AX:=(AH shl 8)+AL;
          CX:=(CH shl 8)+CL;
          intr($10,regs);
     end;
end;

{Convert a string to uppercase}
function upper(what:string):string;
var tempwhat:integer;
begin
     for tempwhat:=1 to length(what) do
         if (what[tempwhat]>='a') and (what[tempwhat]<='z') then
            dec(what[tempwhat],32);
     upper:=what;
end;

{Convert a string to lowercase}
function lower(what:string):string;
var tempwhat:integer;
begin
     for tempwhat:=1 to length(what) do
         if (what[tempwhat]>='A') and (what[tempwhat]<='Z') then
            inc(what[tempwhat],32);
     lower:=what;
end;

{Draw a box around some text}
procedure surround(bd,wx,wy,bgcol,fgcol,txcol:byte;what:string);
var boxchar:char;
    boxloop:byte;

begin
     textcolor(fgcol);
     textbackground(bgcol);
     gotoxy(wx,wy);
     case bd of
          0:boxchar:='';
          1:boxchar:='';
          2:boxchar:='';
     end;
     write(boxchar);
     case bd of
          0:boxchar:='';
          1:boxchar:='';
          2:boxchar:='';
     end;
     gotoxy(wx+length(what)+1,wy);
     write(boxchar);
     case bd of
          0:boxchar:='';
          1:boxchar:='';
          2:boxchar:='';
     end;
     gotoxy(wx,wy+2);
     write(boxchar);
     case bd of
          0:boxchar:='';
          1:boxchar:='';
          2:boxchar:='';
     end;
     gotoxy(wx+length(what)+1,wy+2);
     write(boxchar);
     case bd of
          0:boxchar:='';
          1:boxchar:='';
          2:boxchar:='';
     end;
     for boxloop:=succ(wx) to wx+length(what) do
     begin
          gotoxy(boxloop,wy);
          write(boxchar);
          gotoxy(boxloop,succ(wy));
          write(' ');
          gotoxy(boxloop,wy+2);
          write(boxchar);
     end;
     case bd of
          0:boxchar:='';
          1:boxchar:='';
          2:boxchar:='';
     end;
     gotoxy(wx,succ(wy));
     write(boxchar);
     gotoxy(wx+length(what)+1,succ(wy));
     write(boxchar);
     textcolor(txcol);
     gotoxy(succ(wx),succ(wy));
     write(what);
end;

{Centre text on current line}
procedure centre(cttext:string);
begin
     gotoxy((80-length(cttext)) div 2,wherey);
     write(cttext);
end;

{Set text background and foreground}
procedure textcolour(bgcol,fgcol:byte);
begin
     textcolor(fgcol);
     textbackground(bgcol);
end;

{Wait for a key to be pressed}
procedure waitkey;
var buffer:char;
begin
     buffer:=readkey;
     if buffer=#0 then buffer:=readkey;
end;

{Returns text attribute of two colours}
function get_attr(cbg,cfg:byte):byte;
begin
     get_attr:=(cbg*16)+cfg;
end;

{Place a string of text (Upto 16 chars) in the keyboard buffer}
procedure buffer_write(bwstr:string;hzero:boolean);
var key_loop:byte;

begin
     mem[$0040:$001a]:=$1e;
     mem[$0040:$001c]:=$1e;
     for key_loop:=1 to length(bwstr) do
     begin
          if not hzero then memw[$0040:mem[$0040:$001c]]:=ord(bwstr[key_loop])+(256*ord(bwstr[key_loop])) else
             memw[$0040:mem[$0040:$001c]]:=0+(256*ord(bwstr[key_loop]));
          inc(mem[$0040:$001c],2);
     end;
end;

{Execute a DOS command}
procedure execute(command:string);
begin
     setmemtop(heapptr);
     swapvectors;
     exec(getenv('COMSPEC'),'/C '+command);
     swapvectors;
     setmemtop(HeapEnd);
end;

{Add leading zeros to a number until it is LEN chars long and convert to a string}
function zero(number:longint;len:byte):string;
var text:string;
begin
     str(number,text);
     while length(text)<len do text:='0'+text;
     while length(text)>len do delete(text,length(text),1);
     zero:=text;
end;

{Search DOS command line for a parameter}
function searchparam(param:string):boolean;
var loop:byte;
begin
     searchparam:=false;
     param:=upper(param);
     if paramcount>0 then
        for loop:=1 to paramcount do if upper(paramstr(loop))=param then
            searchparam:=true;
end;

begin
end.
