{===========================================================================}
{ Wiggly Worm '94 Special Edition by J.P.Boggis                             }
{===========================================================================}
{ Wiggly Worm '94 is an updated version of the classic worm/snake game,     }
{ featuring multiplayer game play, levels, power-up icons, lots of          }
{ configuration options for varied game play, etc.                          }
{                                                                           }
{ It was developed in 1994 using Borland Turbo Pascal 6.0, but is known to  }
{ work with Turbo Pascal 7.0 also.                                          }
{---------------------------------------------------------------------------}
{ This program is free software; you can redistribute it and/or modify it   }
{ under the terms of the GNU General Public License as published by the     }
{ Free Software Foundation; either version 2 of the License, or (at your    }
{ option) any later version.                                                }
{                                                                           }
{ This program is distributed in the hope that it will be useful, but       }
{ WITHOUT ANY WARRANTY; without even the implied warranty of                }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         }
{ General Public License for more details.                                  }
{                                                                           }
{ You should have received a copy of the GNU General Public License along   }
{ with this program; if not, write to the Free Software Foundation, Inc.,   }
{ 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                   }
{---------------------------------------------------------------------------}
{ Started by J.P.Boggis (AKA JC Digita) on 07/10/1993.                      }
{                                                                           }
{    Release 2.0  -  24/01/1994                                             }
{    Release 2.1  -  20/02/1994                                             }
{    Release 2.2  -  22/02/1994                                             }
{    Release 2.3  -  23/02/1994                                             }
{    Release 2.4  -  05/04/1994                                             }
{    Release 2.5  -  27/12/2000  -  Special Edition                         }
{===========================================================================}
{ email@jcdigita.com                                       www.jcdigita.com }
{===========================================================================}


{$S-}


uses crt,dos,graph,wormunit,wormhelp,keybiz,mouse;


{***  CPU independant delay  ***}
{ If not using t7tplfix patch for Win2K, search for delay function }
{ replace with wait_ms, otherwise game will not run at a sensible  }
{ speed!                                                           }
procedure wait_ms(ms:word); assembler;
asm
   mov ax, 1000;
   mul ms;
   mov cx, dx;
   mov dx, ax;
   mov ah, $86;
   int $15;
end;

{Register EGA/VGA graphics driver and Sanserif font}
procedure fonts;
var drv1:integer;
begin
     drv1:=registerbgidriver(@jcdgf);
     drv1:=registerbgifont(@jcdfnt);
end;

{Initiate VGA 640x480 graphics}
function init_gfx:boolean;
var graf_error,gd,gm:integer;
begin
     gd:=0;
     initgraph(gd,gm,'');
     graf_error:=graphresult;
     if graf_error=grok then init_gfx:=true else init_gfx:=false;
end;

{Close graphics screen, etc.}
procedure closedown;
begin
     if interrupts then
     begin
          setintvec($09,old09);
          setintvec($1C,old1C);
     end;
     nosound;
     closegraph;
     if endmessage then
     begin
          textattr:=lightgray;
          writeln('ͻ');
          write('  ');
          textattr:=white;
          write('You have been playing...');
          textattr:=lightgray;
          writeln('                                        ');
          writeln('                                                                  ');

          write('               ');
          textcolour(blue,lightblue);
          write('');
          textattr:=lightgray;
          writeln('                ');

          write('               ');
          textcolour(blue,lightblue);
          write('  ');
          textcolour(blue,lightcyan);
          write('W I G G L Y   W O R M   '' 9 4');
          textcolour(blue,lightblue);
          write('  ');
          textattr:=darkgray;
          write('');
          textattr:=lightgray;
          writeln('              ');

          write('               ');
          textcolour(blue,lightblue);
          write('  ');
          textcolour(blue,white);
          write('     - Special Edition -     ');
          textcolour(blue,lightblue);
          write('  ');
          textattr:=darkgray;
          write('');
          textattr:=lightgray;
          writeln('              ');

          write('               ');
          textcolour(blue,lightblue);
          write('');
          textattr:=darkgray;
          write('');
          textattr:=lightgray;
          writeln('              ');
          write('                 ');
          textattr:=darkgray;
          write('');
          textattr:=lightgray;
          writeln('              ');
          writeln('                                                                  ');
          writeln('Ķ');
          write(' ');
          textattr:=white;
          write('    Written by J.P.Boggis 24/01/1994 - '+verdate+'               ');
          textattr:=lightgray;
          writeln(' ');
          writeln('ͼ');
          writeln;

          textattr:=lightgreen;
          write('   Have a nice dos (Yawn!)...');
          textattr:=lightgray;
          writeln;
     end;
     save_configuration;
end;

{Clear keyboard buffers of players}
procedure flush_buffers;
var loop:byte;
begin
     for loop:=1 to 3 do
     begin
          bufhead[loop]:=1;
          buftail[loop]:=1;
     end;
end;

{Clear neccessary variables between levels}
procedure clear_before_level;
var loop,loop2:word;
begin
     for loop:=0 to 3 do player[loop].col:=0;
     for loop:=0 to 3 do
     begin
          if loop=0 then player[loop].levscore:=-1 else
             player[loop].levscore:=0;
          player[loop].tailspeed:=1;
          player[loop].tailcount:=0;
          player[loop].deadcount:=0;
          player[loop].lastscore:=0;
          player[loop].tailhold:=1;
          player[loop].len:=1;
          player[loop].dir:=5;
          repeat
                loop2:=random(7)+1;
          until (loop2<>player[1].col) and
                (loop2<>player[2].col) and
                (loop2<>player[3].col);
          player[loop].col:=loop2;
          if loop<>0 then
          begin
               laser_onscreen[loop]:=false;
               wormmoving[loop]:=false;
               slowdowncount[loop]:=0;
               speedupcount[loop]:=0;
               mpointscount[loop]:=0;
               key[loop].fire:=false;
               zeropowercol[loop]:=0;
               supercount[loop]:=0;
               stuncount[loop]:=0;
               powercol[loop]:=0;
               invcount[loop]:=0;
               eatcount[loop]:=0;
               key[loop].dir:=1;
               lastdir[loop]:=5;
               update[loop]:=0;
          end;
     end;
     for loop:=1 to 3 do
     begin
          speed[loop]:=playerspeed*2;
          speedstore[loop]:=speed[loop];
     end;
     if fastcomputers then
     begin
          loop2:=0;
          for loop:=1 to 3 do if player[loop].ptype=human then inc(loop2);
          if loop2>0 then
          begin
               loop2:=0;
               for loop:=1 to 3 do if (player[loop].ptype=human) and not player[loop].dead then inc(loop2);
               if loop2=0 then for loop:=1 to 3 do if player[loop].ptype=computer then speed[loop]:=0;
          end;
     end;
     for loop:=1 to maximumicons do with icon[loop] do
     begin
          if loop<=maxicons then
          begin
               howlong:=round((random(iconoffscreen)+1)*18.2);
               action:=1;
          end else
          begin
               howlong:=0;
               action:=0;
          end;
          doaction:=false;
          numb:=false;
          x:=1; y:=1;
          itype:=1;
     end;
     flush_buffers;
end;

{Clear/setup game variables before game}
procedure clear;
var loop:word;
begin
     for loop:=0 to 3 do
     begin
          if player[loop].ptype>0 then player[loop].dead:=false else
             player[loop].dead:=true;
          if loop=0 then player[loop].score:=-1 else
             player[loop].score:=0;
          player[loop].lives:=playerlives;
          player[loop].supershots:=0;
          player[loop].deadlevel:=0;
          player[loop].megashots:=0;
          player[loop].threeway:=0;
          player[loop].numbers:=0;
          player[loop].saveyou:=0;
          player[loop].noicons:=0;
          player[loop].maxlen:=0;
          player[loop].eats:=0;
     end;
     for loop:=1 to 3 do nextlife[loop]:=10000;
     {***  Worm length when you crash  ***}
     case wormmethod of
          1:begin divideby:=10; multiply:=9; end;  {10%}
          2:begin divideby:=10; multiply:=8; end;  {20%}
          3:begin divideby:=10; multiply:=7; end;  {30%}
          4:begin divideby:=10; multiply:=6; end;  {40%}
          5:begin divideby:=10; multiply:=5; end;  {50%}  {Default}
          6:begin divideby:=10; multiply:=4; end;  {60%}
          7:begin divideby:=10; multiply:=3; end;  {70%}
          8:begin divideby:=10; multiply:=2; end;  {80%}
          9:begin divideby:=10; multiply:=1; end;  {90%}
          10:begin divideby:=1; multiply:=1; end;  {Stays the same}
     end;
     escape:=false;
     pause:=false;
     level:=0;
end;

{Clear hiscore table}
procedure clear_hiscore;
var loop:byte;

begin
     for loop:=1 to 40 do with hiscore[loop] do
     begin
          name:='J.P.Boggis 2001';
          score:=(41-loop)*250;
          numbers:=0;
          noicons:=0;
          maxlen:=0;
          level:=1;
          speed:=0;
     end;
end;

{Save current high scores to disk}
procedure save_hiscore;
var save:file of scorefile;
begin
     filemode:=2;
     assign(save,'\WORM94.HSC');
     {$I-}
     rewrite(save);
     write(save,hiscore);
     close(save);
     {$I+}
     if ioresult<>0 then ky:=ky;
end;

{Load high scores from disk}
procedure load_hiscore;
var load:file of scorefile;
begin
     filemode:=0;
     assign(load,'\WORM94.HSC');
     {$I-}
     reset(load);
     read(load,hiscore);
     close(load);
     {$I+}
     if ioresult<>0 then clear_hiscore;
     filemode:=2;
end;

{Set up variables, etc.}
procedure setup;
var loop:word;
begin
     worms:=@wormbit;
     icons:=@iconbit;
     numbs:=@numbbit;
     walls:=@wallbit;
     wormtitle:=@wormlogo;
     if searchparam('/B') then endmessage:=false else endmessage:=true;
     if searchparam('/Q') then snd:=false else snd:=true;
     for loop:=1 to 3 do player[loop].head.dir:=0;
     player[1].ptype:=human;
     player[2].ptype:=computer;
     player[3].ptype:=notplaying;
     exiton:=false;
     priority:=0;
     boss:=false;
     oval:=255;
     del:=0;
     for loop:=0 to 3 do oldscore[loop]:=2147483647;
     {***  Witty comments...  ***}
     comment[1]:='Surely you can do better than that?';
     comment[2]:='Well, I suppose that''s better than nothing!';
     comment[3]:='Well, I suppose you''re getting better!';
     comment[4]:='Reasonable for a beginner!';
     comment[5]:='Getting better, getting better!';
     comment[6]:='You''re starting to get the hang of it now!';
     comment[7]:='You''re definitely getting the hang of it now!';
     comment[8]:='Keep playin'', yer getting better!';
     comment[9]:='Keep playin'', yer much better!';
     comment[10]:='Keep playin'', yer playing well!';
     comment[11]:='Pretty good!';
     comment[12]:='You''re getting reasonable scores at last!';
     comment[13]:='You''re getting pretty good at this now!';
     comment[14]:='Great score!';
     comment[15]:='Brilliant score!';
     comment[16]:='Can''t get much better!';
     comment[17]:='Amazing!';
     comment[18]:='Astounding!';
     comment[19]:='Excellent!';
     comment[20]:='Outta this world!';
     comment[21]:='Super human player!';
     comment[22]:='You are superior!!!';
     comment[23]:='Surely, you''re not that hooked?';
     comment[24]:='Come on, you must get bored of this!';
     comment[25]:='Come on, you must be cheating!';
     comment[26]:='How on earth did you get that score?';
     comment[27]:='You''re just too good!';
     comment[28]:='You''ve definitely got the knack of it!';
     comment[29]:='You''re totally out of this world!';
     comment[30]:='How many hours have ya been playing for?';
     comment[31]:='No words can describe how good you are!';
     comment[32]:='Unbelievable!';
     comment[33]:='You must be the best player ever!';
     comment[34]:='Take a break!';
     comment[35]:='Super reflexes?';
     comment[36]:='Brilliant co-ordination!';
     comment[37]:='I can''t ever fault that!';
     clear_hiscore;
     flush_buffers;
     {***  Install custom keyboard and timer interrupt routines  ***}
     if interrupts then
     begin
          getintvec($1C,old1C);
          getintvec($09,old09);
          setintvec($09,@keyb_handler);
          setintvec($1C,@time_handler);
     end;
     clear;
end;

{Returns rank of player as a string}
function rank(no:byte):rankstr;
begin
     case no of
          1,21,31:rank:=convert(no)+'ST';
          2,22,32:rank:=convert(no)+'ND';
          3,23,33:rank:=convert(no)+'RD';
          4..20,24..30,34..40:rank:=convert(no)+'TH';
          else rank:='NIL';
     end;
end;

{Make a string full of the character CH of length LEN}
function strfill(ch:char;len:byte):namestr;
var temp:namestr;
begin
     temp:='';
     while length(temp)<>len do temp:=temp+ch;
     strfill:=temp;
end;

{End of level bonuses}
procedure endoflevel(noendbonus:byte);
var order:array[1..3] of byte;
    loop,loop2,index:byte;
    lp:word;

begin
     addchord(587,293,true);
     addchord(494,250,false);
     addchord(391,196,false);
     addchord(293,148,false);
     addchord(524,293,false);
     addchord(441,220,false);
     addchord(373,186,false);
     addchord(293,148,false);
     addchord(391,196,false);
     addchord(391,98,false);
     addchord(373,98,false);
     addchord(391,98,false);
     addchord(391,98,false);
     addchord(373,98,false);
     addchord(391,98,false);
     addchord(391,98,false);
     {***  Draw window border  ***}
     setcolor(black);
     rectangle(88,156,552,324);
     setcolor(darkgray);
     rectangle(89,157,551,323);
     rectangle(93,161,547,319);
     setcolor(lightgray);
     rectangle(90,158,550,322);
     rectangle(92,160,548,320);
     setcolor(white);
     rectangle(91,159,549,321);
     setfillstyle(1,black);
     bar(94,162,546,318);
     {***  Level bonuses text  ***}
     grafxy(1,21);
     grafcentln('END OF LEVEL '+convert(level)+' BONUSES',yellow,brown);
     grafcentln(''+strfill('',length(convert(level)))+'',yellow,brown);
     grafln;
     grafcentln(#25+'RANK  '+#25+'PLAYER   '+#25+'LEVEL SCORE    '+#25+'BONUS POINTS',lightcyan,cyan);
     grafcentln('',cyan,darkgray);
     if noendbonus=0 then
     begin
          {***  Rank players by level score  ***}
          for loop:=1 to 3 do order[loop]:=0;
          for loop:=1 to 3 do if (player[loop].ptype>0) and not player[loop].dead then
          begin
               index:=1;
               while (player[loop].levscore<=player[order[index]].levscore) and (index<4) do inc(index);
               if index<3 then for loop2:=3 downto index+1 do order[loop2]:=order[loop2-1];
               order[index]:=loop;
          end;
          {***  Display level score rankings  ***}
          for loop:=1 to 3 do if order[loop]<>0 then
          begin
               if loop=3 then index:=4 else index:=loop;
               grafcentln(rank(loop)+'    PLAYER '+convert(order[loop])+'  '+
                          trunc_str(convert(player[order[loop]].levscore),16)+
                          trunc_str(convert(round((longint(levelendpoints)/10)/longint(index))),7)+
                          trunc_str('x'+convert(level),7),white,darkgray);
               player[order[loop]].score:=player[order[loop]].score+round(((longint(levelendpoints)*
                      longint(level))/10)/longint(index));
          end else grafln;
     end else
     begin
          grafln;
          case noendbonus of
               1:grafcentln('ALL PLAYERS DEAD - NO END OF LEVEL BONUS!',white,darkgray);
               2:grafcentln('GAME ENDED - NO END OF LEVEL BONUS!',white,darkgray);
          end;
          grafln;
     end;
     {***  Rank players by current score  ***}
     for loop:=1 to 3 do order[loop]:=0;
     for loop:=1 to 3 do if player[loop].ptype>0 then
     begin
          index:=1;
          while (player[loop].score<=player[order[index]].score) and (index<4) do inc(index);
          if index<3 then for loop2:=3 downto index+1 do order[loop2]:=order[loop2-1];
          order[index]:=loop;
     end;
     {***  Display current rankings  ***}
     grafln;
     grafln;
     grafcentln(#25+'RANK  '+#25+'PLAYER   '+#25+'SCORE    '+#25+'ICONS  '+#25+'NUMBERS  '+#25+'MAX. LEN',lightcyan,cyan);
     grafcentln('',cyan,darkgray);
     for loop:=1 to 3 do if order[loop]<>0 then
     begin
          grafcentln(rank(loop)+'    PLAYER '+convert(order[loop])+'  '+
                     trunc_str(convert(player[order[loop]].score),10)+
                     trunc_str(convert(player[order[loop]].noicons),8)+
                     trunc_str(convert(player[order[loop]].numbers),10)+
                     trunc_str(convert(player[order[loop]].maxlen),9),white,darkgray);
          disp_score(order[loop]);
     end else grafln;
     grafln;
     grafln;
     grafcentln('(Everyone press fire to continue...)',lightgreen,green);
     waitfor(10,false,true,true,false);
     levbonus:=true;
end;

{Has player got a hi-score?  If so, let them enter their name}
procedure player_hiscore(no:byte);
var got_hiscore:boolean;
    x,y:integer;
    temp:string[25];

{Draw face with worm bits}
procedure worm_face(x,y,col:byte;happy:boolean);
begin
     putimage((x-1)*8,(y-1)*8,worms^[col],normalput);
     putimage((x+5)*8,(y-1)*8,worms^[col],normalput);
     putimage((x+2)*8,(y+2)*8,worms^[col],normalput);
     if happy then
     begin
          putimage(x*8,((y+7)*8)-2,worms^[col],normalput);
          putimage((x+1)*8,(y+7)*8,worms^[col],normalput);
          putimage((x+2)*8,((y+7)*8)+1,worms^[col],normalput);
          putimage((x+3)*8,(y+7)*8,worms^[col],normalput);
          putimage((x+4)*8,((y+7)*8)-2,worms^[col],normalput);
          putimage((x+5)*8,((y+7)*8)-6,worms^[col],normalput);
          putimage((x+6)*8,((y+7)*8)-12,worms^[col],normalput);
          putimage((x-1)*8,((y+7)*8)-6,worms^[col],normalput);
          putimage((x-2)*8,((y+7)*8)-12,worms^[col],normalput);
     end else
     begin
          putimage(x*8,((y+5)*8)+2,worms^[col],normalput);
          putimage((x+1)*8,(y+5)*8,worms^[col],normalput);
          putimage((x+2)*8,((y+5)*8)-1,worms^[col],normalput);
          putimage((x+3)*8,(y+5)*8,worms^[col],normalput);
          putimage((x+4)*8,((y+5)*8)+2,worms^[col],normalput);
          putimage((x+5)*8,((y+5)*8)+6,worms^[col],normalput);
          putimage((x+6)*8,((y+5)*8)+12,worms^[col],normalput);
          putimage((x-1)*8,((y+5)*8)+6,worms^[col],normalput);
          putimage((x-2)*8,((y+5)*8)+12,worms^[col],normalput);
     end;
end;

begin
     addnote(0,4,false);
     repeat until (qpos>qlen) or escape;
     if (player[no].head.dir in [1..40]) then
     begin
          got_hiscore:=true;
          addchord(587,148,true);
          addchord(740,148,false);
          addchord(880,148,false);
          addchord(1171,148,false);
          addchord(1171,148,false);
          addnote(0,4,false);
     end else
     begin
          got_hiscore:=false;
          addchord(350,176,true);
          addchord(417,176,false);
          addchord(524,176,false);
          addchord(831,176,false);
          addchord(781,176,false);
          addchord(697,176,false);
          addchord(391,196,false);
          addchord(465,196,false);
          addchord(555,196,false);
          addchord(781,196,false);
          addchord(697,196,false);
          addchord(660,196,false);
          addchord(262,167,false);
          addchord(333,167,false);
          addchord(391,167,false);
          addchord(781,167,false);
          addchord(697,167,false);
          addchord(660,167,false);
          addchord(697,176,false);
          addchord(524,176,false);
          addchord(417,176,false);
          addchord(350,176,false);
          addchord(350,176,false);
          addchord(350,176,false);
          addnote(0,4,false);
     end;
     {***  Draw window border  ***}
     setcolor(black);
     rectangle(72,156,568,324);
     setcolor(darkgray);
     rectangle(73,157,567,323);
     rectangle(77,161,563,319);
     setcolor(lightgray);
     rectangle(74,158,566,322);
     rectangle(76,160,564,320);
     setcolor(white);
     rectangle(75,159,565,321);
     setfillstyle(1,black);
     bar(78,162,562,318);
     {***  Display player number  ***}
     settextstyle(sansseriffont,horizdir,6);
     tempstr:='PLAYER '+convert(no);
     x:=((640-textwidth(tempstr)) div 2)+8;
     y:=((480-textheight(tempstr)) div 2)-12-49;
     setcolor(lightgray);
     outtextxy(x,y+1,tempstr);
     setcolor(player[no].col+8);
     outtextxy(x,y,tempstr);
     settextstyle(defaultfont,horizdir,1);
     grafxy(1,28);
     if not got_hiscore then  {***  Player hasn't got a hiscore  ***}
     begin
          player[no].head.dir:=0;
          grafcentln(comment[1],lightcyan,cyan);
          grafxy(1,33);
          grafcentln('YOU HAVEN''T GOT A HIGH-SCORE!!!',lightmagenta,magenta);
          grafxy(1,38);
          grafcentln('(Press FIRE to continue...)',lightgreen,green);
          worm_face(13,27,player[no].col,false);
          worm_face(62,27,player[no].col,false);
          waitfor(5,false,true,false,false);
     end else  {***  Player has a high-score  ***}
     begin
          y:=succ(round((player[no].score/1000)*0.75));
          if y>37 then y:=37;
          if y<1 then y:=1;
          grafcentln(comment[y],lightcyan,cyan);
          {***  Display rest of graphics and let player enter their name  ***}
          worm_face(13,27,player[no].col,true);
          worm_face(62,27,player[no].col,true);
          grafln;
          grafln;
          grafcentln('YOU''RE '+rank(player[no].head.dir)+' IN THE HIGH-SCORES!',lightmagenta,magenta);
          grafln;
          grafcentln('PLEASE ENTER YOUR NAME...',lightgreen,green);
          grafln;
          grafcentln('Ŀ',lightgray,darkgray);
          grafcentln('                         ',lightgray,darkgray);
          grafcent('',lightgray,darkgray);
          grafxy(gf.x,gf.y-1);
          grafcent('',lightblue,blue);
          buffer:=true;
          if player[no].ptype=computer then buffer_write('Computer '+convert(no)+'!'+#13,false);
          temp:='';
          repeat until (qpos>qlen) or escape;
          repeat
                ky:=readkey;
                if ky=#0 then
                begin
                     ky:=readkey;
                     if ky=#83 then ky:=#8 else ky:=#255;
                end;
                case ky of
                     #255:ky:=ky;
                     #8:if length(temp)>0 then
                     begin
                          addnote(293,0,true);
                          addnote(250,0,false);
                          grafcent(strfill('',length(temp)),lightblue,blue);
                          temp[0]:=char(ord(temp[0])-1);
                          grafcent(temp,lightcyan,cyan);
                     end;
                     else if (length(temp)<25) and not (ky in [#27,#13]) then
                     begin
                          addnote(1171,0,true);
                          addnote(998,0,false);
                          grafcent(strfill('',length(temp)),lightblue,blue);
                          temp:=temp+ky;
                          grafcent(temp,lightcyan,cyan);
                     end;
                end;
                repeat until (qpos>qlen) or escape;
          until escape or (ky=#13);
          buffer_write('',false);
          addnote(0,4,false);
          repeat until (qpos>qlen) or escape;
          hiscore[player[no].head.dir].noicons:=player[no].noicons;
          hiscore[player[no].head.dir].numbers:=player[no].numbers;
          hiscore[player[no].head.dir].level:=player[no].deadlevel;
          hiscore[player[no].head.dir].maxlen:=player[no].maxlen;
          hiscore[player[no].head.dir].speed:=playerspeed;
          if not boss then if escape then
          begin
               case random(5) of
                    0:hiscore[player[no].head.dir].name:='Mr Escape!';
                    1:hiscore[player[no].head.dir].name:='Mr Impatient!';
                    2:hiscore[player[no].head.dir].name:='Mr Hammer The Escape Key!';
                    3:hiscore[player[no].head.dir].name:='Mr "What does ESCAPE do"?';
                    4:hiscore[player[no].head.dir].name:='Why did you press ESCAPE?';
               end;
               if player[no].ptype=computer then hiscore[player[no].head.dir].name:='Computer '+convert(no)+'!';
          end else if temp='' then
          begin
               case random(6) of
                    0:hiscore[player[no].head.dir].name:='Mr No Name!';
                    1:hiscore[player[no].head.dir].name:='Mr Unknown!';
                    2:hiscore[player[no].head.dir].name:='A very lazy person!';
                    3:hiscore[player[no].head.dir].name:='Try entering your name!';
                    4:hiscore[player[no].head.dir].name:='Why not enter your name?';
                    5:hiscore[player[no].head.dir].name:='Mr confidential!';
                    6:hiscore[player[no].head.dir].name:='Mr Return!';
               end;
               if player[no].ptype=computer then hiscore[player[no].head.dir].name:='Computer '+convert(no)+'!';
          end else hiscore[player[no].head.dir].name:=temp;
          addchord(1565,391,true);
          addchord(1477,391,false);
          addchord(1565,391,false);
          addchord(1171,441,false);
          addchord(1108,441,false);
          addchord(1171,441,false);
          addchord(998,391,false);
          addchord(928,391,false);
          addchord(998,391,false);
          addchord(391,196,false);
          addchord(391,98,false);
          addchord(391,98,false);
          addchord(391,98,false);
          repeat until (qpos>qlen) or escape;
     end;
end;

{Ranks specified player in high-score table}
procedure rank_player(no:byte);
var index,loop:integer;
    goon:boolean;

begin
     {***  Rank player in high-score table  ***}
     index:=1;
     repeat
           goon:=false;
           if player[no].score<=hiscore[index].score then goon:=true;
           if goon then inc(index);
           if index>40 then goon:=false;
     until not goon;
     if (index in [1..40]) and (player[1].head.dir in [1..40]) then
        if (player[1].head.dir>=index) then inc(player[1].head.dir);
     if (index in [1..40]) and (player[2].head.dir in [1..40]) then
        if (player[2].head.dir>=index) then inc(player[2].head.dir);
     if (index in [1..40]) and (player[3].head.dir in [1..40]) then
        if (player[3].head.dir>=index) then inc(player[3].head.dir);
     player[no].head.dir:=index;
     if (index in [1..39]) then for loop:=40 downto index+1 do hiscore[loop]:=hiscore[loop-1];
     if (index in [1..40]) then
     begin
          hiscore[player[no].head.dir].name:='Player '+convert(no)+'!';
          hiscore[player[no].head.dir].score:=player[no].score;
     end;
end;

{Draw a single unit of the wall}
procedure draw_wallunit(x,y,wall_type:byte);
begin
     putimage(x*8,(y+3)*8,walls^[wall_type],normalput);
     screen[x,y]:=3;
end;

{Draw random wall blocks all over the place}
procedure random_blocks;
var loop,rx,ry:byte;
    limit:word;

begin
     {***  The harder the level difficulty, the more blocks there are!!!  ***}
     for loop:=1 to random((levelendpoints div 100)+1)+10 do
     begin
          limit:=0;
          repeat
                inc(limit);
                rx:=succ(random(77))+1;
                ry:=succ(random(54))+1;
          until (screen[rx,ry]=0) or (limit>20);
          if screen[rx,ry]=0 then draw_wallunit(rx,ry,random(21)+1);
     end;
end;

{Draw single wall}
procedure draw_walls;
var wall_x,wall_y,wall_len,wall_dir,wall_type,wall_loop:byte;
begin
     wall_x:=succ(random(77))+1;
     wall_y:=succ(random(54))+1;
     wall_dir:=succ(random(3));
     wall_type:=random(21)+1;
     case wall_dir of
          1:begin
                 wall_len:=succ(random(wall_y));
                 for wall_loop:=wall_y downto wall_y-pred(wall_len) do draw_wallunit(wall_x,wall_loop,wall_type);
          end;
          2:begin
                 wall_len:=succ(random(79-wall_x));
                 for wall_loop:=wall_x to wall_x+pred(wall_len) do draw_wallunit(wall_loop,wall_y,wall_type);
          end;
          3:begin
                 wall_len:=succ(random(56-wall_y));
                 for wall_loop:=wall_y to wall_y+pred(wall_len) do draw_wallunit(wall_x,wall_loop,wall_type);
          end;
          4:begin
                 wall_len:=succ(random(wall_x));
                 for wall_loop:=wall_x downto wall_x-pred(wall_len) do draw_wallunit(wall_loop,wall_y,wall_type);
          end;
     end;
end;

{Blank out graphics on playing field (Before game and between levels)}
procedure clear_playing_field;
var loop,loop2,loop3:word;
begin
     setfillstyle(1,black);
     bar(8,32,631,471);
     for loop:=0 to 79 do
         for loop2:=0 to 56 do
             if (loop in [0,79]) or (loop2 in [0,56]) then
             begin
                  screen[loop,loop2]:=scredge;
                  for loop3:=1 to 3 do scrtail[loop,loop2,loop3]:=scredge;
             end else
             begin
                  screen[loop,loop2]:=0;
                  for loop3:=1 to 3 do scrtail[loop,loop2,loop3]:=0;
             end;
end;

{Is the worm NO playing anymore?}
function worm_playing(no:byte):boolean;
begin
     if player[no].ptype>0 then worm_playing:=true else worm_playing:=false;
end;

{Randomizes position of worm NO}
procedure randomize_wormpos(no:byte);
begin
     repeat
           player[no].head.x:=random(78)+1;
           player[no].head.y:=random(55)+1;
     until (screen[player[no].head.x,player[no].head.y] and 15=0);
     player[no].tail:=player[no].head;
     player[no].del:=player[no].head;
end;

{Displays worm segment (Bit) of worm NO at it's current X, Y}
procedure display_worm(no:byte;setscr:boolean;body:boolean);
var rnd:word;
begin
     with player[no] do
     begin
          if not wormmoving[no] and (stuncount[no]=0) and (deadcount=0) then
          begin  {***  Display segment of worm before player starts it moving  ***}
               if setscr then
               begin
                    screen[head.x,head.y]:=1;
                    if scrtail[head.x,head.y,no]>0 then
                    begin
                         rnd:=scrtail[head.x,head.y,no];
                         scrtail[head.x,head.y,no]:=0;
                         while rnd and 15<>0 do
                         begin
                              scrtail[head.x,head.y,no]:=(scrtail[head.x,head.y,no] shl 4)+(rnd and 15);
                              rnd:=rnd shr 4;
                         end;
                         scrtail[head.x,head.y,no]:=(scrtail[head.x,head.y,no] shl 4)+dir;
                         scrtail[head.x,head.y,no]:=((scrtail[head.x,head.y,no] and 15) shl 12)+
                                                    (((scrtail[head.x,head.y,no] and 240) shr 4) shl 8)+
                                                    (((scrtail[head.x,head.y,no] and 3840) shr 8) shl 4)+
                                                    ((scrtail[head.x,head.y,no] and 61440) shr 12);
                         while (scrtail[head.x,head.y,no] and 15=0) do scrtail[head.x,head.y,no]:=
                               scrtail[head.x,head.y,no] shr 4;
                    end else scrtail[head.x,head.y,no]:=dir;
               end;
               repeat rnd:=random(6)+1; until rnd<>player[no].col;
               setfillstyle(1,black);
               bar(head.x*8,(head.y+3)*8,(head.x*8)+7,((head.y+3)*8)+7);
               setcolor(rnd+8);
               outtextxy(head.x*8,(head.y+3)*8,convert(no));
          end else  {***  Display segment of moving worm  ***}
          begin
               if setscr then
               begin
                    screen[head.x,head.y]:=1;
                    if scrtail[head.x,head.y,no]>0 then
                    begin
                         rnd:=scrtail[head.x,head.y,no];
                         scrtail[head.x,head.y,no]:=0;
                         while rnd and 15<>0 do
                         begin
                              scrtail[head.x,head.y,no]:=(scrtail[head.x,head.y,no] shl 4)+(rnd and 15);
                              rnd:=rnd shr 4;
                         end;
                         scrtail[head.x,head.y,no]:=(scrtail[head.x,head.y,no] shl 4)+dir;
                         scrtail[head.x,head.y,no]:=((scrtail[head.x,head.y,no] and 15) shl 12)+
                                                    (((scrtail[head.x,head.y,no] and 240) shr 4) shl 8)+
                                                    (((scrtail[head.x,head.y,no] and 3840) shr 8) shl 4)+
                                                    ((scrtail[head.x,head.y,no] and 61440) shr 12);
                         while (scrtail[head.x,head.y,no] and 15=0) do scrtail[head.x,head.y,no]:=
                               scrtail[head.x,head.y,no] shr 4;
                    end else scrtail[head.x,head.y,no]:=dir;
               end;

               if body then
               begin
                    with player[no] do putimage(head.x*8,(head.y+3)*8,worms^[worm_body(no)],normalput);
               end else
               begin
                    with player[no] do putimage(head.x*8,(head.y+3)*8,worms^[worm_head(no)],normalput);
               end
          end;
     end;
end;

{Changes direction of worm (When turning, etc.)}
procedure change_dir(no:byte);
begin
     with player[no] do
     begin
          if scrtail[head.x,head.y,no] and 61440<>0 then
          begin
               scrtail[head.x,head.y,no]:=(scrtail[head.x,head.y,no] and 4095)+(dir shl 12);
          end else if scrtail[head.x,head.y,no] and 3840<>0 then
          begin
               scrtail[head.x,head.y,no]:=(scrtail[head.x,head.y,no] and 61695)+(dir shl 8);
          end else if scrtail[head.x,head.y,no] and 240<>0 then
          begin
               scrtail[head.x,head.y,no]:=(scrtail[head.x,head.y,no] and 65295)+(dir shl 4);
          end else scrtail[head.x,head.y,no]:=dir;
     end;
end;

{Moves worm's head in current direction}
procedure move_worm(no:byte);
begin
     with player[no] do
     begin
          temp:=head;
          case dir of
               1:dec(temp.y);
               2:inc(temp.x);
               3:inc(temp.y);
               4:dec(temp.x);
          end;
     end;
end;

{Moves worm's tail in current direction}
procedure move_tail(no:byte);
var loop:byte;
begin
     if player[no].tailhold=0 then with player[no] do
     begin
          if tailcount>0 then
          begin
               dec(tailcount);
          end else tailspeed:=1;
          if len<3 then tailspeed:=1;
          for loop:=1 to tailspeed do
          begin
               {***  Move worm's tail  ***}
               del:=tail;
               tail.dir:=scrtail[tail.x,tail.y,no] and 15;
               scrtail[tail.x,tail.y,no]:=scrtail[tail.x,tail.y,no] shr 4;
               if (scrtail[tail.x,tail.y,1]=0) and
                  (scrtail[tail.x,tail.y,2]=0) and
                  (scrtail[tail.x,tail.y,3]=0) then screen[tail.x,tail.y]:=0;
               case tail.dir of
                    1:dec(tail.y);
                    2:inc(tail.x);
                    3:inc(tail.y);
                    4:dec(tail.x);
               end;
               {***  Blank out worm segment under tail DEL pos  ***}
               setfillstyle(1,black);
               if not ((head.x=del.x) and (head.y=del.y)) then
               begin
                    if screen[del.x,del.y]=0 then bar(del.x*8,(del.y+3)*8,(del.x*8)+7,((del.y+3)*8)+7) else
                       if scrtail[del.x,del.y,1]<>0 then putimage(del.x*8,(del.y+3)*8,worms^[worm_body(1)],normalput) else
                          if scrtail[del.x,del.y,2]<>0 then putimage(del.x*8,(del.y+3)*8,worms^[worm_body(2)],normalput) else
                             if scrtail[del.x,del.y,3]<>0 then putimage(del.x*8,(del.y+3)*8,worms^[worm_body(3)],normalput);
               end else if player[no].dead then with icon[no] do
               begin
                    if screen[x,y]=4 then
                    begin
                         setfillstyle(1,black);
                         bar(x*8,(y+3)*8,(x*8)+7,((y+3)*8)+7);
                         screen[x,y]:=0;
                    end;
                    doaction:=false;
                    action:=2;
                    screen[del.x,del.y]:=4;
                    x:=del.x; y:=del.y;
                    howlong:=1092;  {***  Remains on screen for 1 minute  ***}
                    numb:=true;
                    itype:=15;
                    putimage(x*8,(y+3)*8,numbs^[itype],normalput);
               end;
          end;
          dec(len,tailspeed-1);
     end else
     begin
          dec(player[no].tailhold);
          inc(player[no].len);
     end;
end;

{Puts current direction into pos of HEAD in SCREEN array}
procedure place_dir(no:byte);
begin
     with player[no] do
     begin
          screen[head.x,head.y]:=screen[head.x,head.y] shl 8;
          screen[head.x,head.y]:=screen[head.x,head.y] and $FFF0;
          screen[head.x,head.y]:=screen[head.x,head.y]+dir;
     end;
end;

{Make worm NO dead}
procedure worm_dead(no:byte);
var loglen:word;
begin
     if (invcount[no]>0) or (player[no].levscore-player[no].lastscore<51) then
     begin
          if priority<=sp_notdead then
          begin
               priority:=sp_notdead;
               addnote(2000,0,true);
               addnote(1950,0,false);
               addnote(2000,0,false);
               addnote(2050,0,false);
               addnote(2100,0,false);
          end;
          if (player[no].dir in [1..4]) then lastdir[no]:=player[no].dir;
          wormmoving[no]:=false;
          player[no].dir:=5;
     end else with player[no] do
     begin
          if player[no].saveyou>0 then
          begin
               if priority<=sp_notdead then
               begin
                    priority:=sp_notdead;
                    addnote(1000,0,true);
                    addnote(950,0,false);
                    addnote(1000,0,false);
               end;
               if (player[no].dir in [1..4]) then lastdir[no]:=player[no].dir;
               dec(player[no].saveyou);
               wormmoving[no]:=false;
               player[no].dir:=5;
          end else
          begin
               player[no].lastscore:=player[no].levscore;
               dec(lives);
               disp_lives(no);
               if lives=0 then
               begin
                    deadcount:=len+tailhold;
                    deadlevel:=level;
                    dead:=true;
               end else
               begin
                    loglen:=len+tailhold;
                    if (wormmethod in [1..9]) then deadcount:=round((loglen/divideby)*multiply) else
                       deadcount:=0;
                    while (loglen-deadcount<2) and (deadcount>0) do dec(deadcount);
                    if deadcount=0 then
                    begin
                         if priority<=sp_dead then
                         begin
                              priority:=sp_dead;
                              addnote(random(30)+20,1,true);
                              addnote(random(30)+20,1,false);
                         end;
                         wormmoving[no]:=false;
                    end;
               end;
               if (player[no].dir in [1..4]) then lastdir[no]:=player[no].dir;
               key[no].fire:=false;
               player[no].dir:=5;
               key[no].dir:=0;
               tailspeed:=1;
          end;
     end;
end;

{Has worm NO hit another worm, edge of screen or a wall?}
procedure test_collision(no:byte);
begin
     if (screen[temp.x,temp.y] in [scrworm,scredge,scrwall]) then
     begin
          if ((eatcount[no]>0) or (player[no].eats>0)) and (screen[temp.x,temp.y]<>scredge) then
          begin
               if priority<=sp_notdead then
               begin
                    priority:=sp_notdead;
                    addnote(30,0,true);
                    addnote(150,1,false);
               end;
               screen[temp.x,temp.y]:=0;
               if eatcount[no]=0 then dec(player[no].eats);
          end else worm_dead(no);
     end;
end;

{Has worm NO collected an icon?}
procedure test_icon(no:byte);
var loop,ico:word;

{Make sound for collecting a number}
procedure numbsound(number:byte);
begin
     if priority<=sp_numb then
     begin
          priority:=sp_numb;
          addnote(3098+(20*number),0,true);
          addnote(2998+(20*number),0,false);
     end;
end;

{Nick other worms tails!}
procedure nick_it;
var loop,count:word;
begin
     count:=0;
     for loop:=1 to 3 do if not player[loop].dead and (loop<>no) and (player[loop].len>2) then
     begin
          inc(count,player[loop].len-2);
          inc(player[loop].tailcount,player[loop].len-2);
          player[loop].tailspeed:=2;
     end;
     inc(player[no].tailhold,count);
     if count=0 then count:=1;
     count:=count*20;
     dec(levelpoints,count);
     inc(player[no].score,count);
     inc(player[no].levscore,count);
end;

begin
     if screen[temp.x,temp.y]=4 then
        for loop:=1 to maxicons do
            if (temp.x=icon[loop].x) and (temp.y=icon[loop].y) then
            begin
                 ico:=icon[loop].itype;
                 if icon[loop].numb then
                 begin
                      case ico of
                           0:begin
                                  ico:=random(51)+25;
                                  inc(player[no].score,ico*10);
                                  inc(player[no].levscore,ico*10);
                                  inc(player[no].tailhold,ico);
                                  dec(levelpoints,ico*10);
                                  numbsound(ico);
                                  ico:=0;
                           end;
                           1..9:begin
                                     numbsound(ico);
                                     inc(player[no].score,ico*10);
                                     inc(player[no].levscore,ico*10);
                                     inc(player[no].tailhold,ico);
                                     dec(levelpoints,ico*10);
                           end;
                           10:numbsound(0);
                           11:begin
                                   numbsound(10);
                                   inc(player[no].score,100);
                                   inc(player[no].levscore,100);
                                   inc(player[no].tailhold,10);
                                   dec(levelpoints,100);
                           end;
                           12:begin
                                   numbsound(25);
                                   inc(player[no].score,250);
                                   inc(player[no].levscore,250);
                                   inc(player[no].tailhold,25);
                                   dec(levelpoints,250);
                           end;
                           13:begin
                                   numbsound(50);
                                   inc(player[no].score,500);
                                   inc(player[no].levscore,500);
                                   inc(player[no].tailhold,50);
                                   dec(levelpoints,500);
                           end;
                           15:begin
                                   if priority<=sp_dead then
                                   begin
                                        priority:=sp_dead;
                                        addnote(65,0,true);
                                        addnote(131,0,false);
                                        addnote(262,0,false);
                                        addnote(524,0,false);
                                        addnote(1043,0,false);
                                        addnote(2093,0,false);
                                   end;
                                   inc(player[no].score,1000);
                                   inc(player[no].levscore,1000);
                                   dec(levelpoints,1000);
                                   update_score:=true;
                           end;
                      end;
                      if ico<>10 then
                      begin
                           update_levelp:=true;
                           update_score:=true;
                      end;
                      inc(player[no].numbers);
                 end else
                 begin
                      if ico=20 then repeat ico:=random_icon; until ico<>20;
                      case ico of
                           1:begin  {***  Increase speed for 10 secs  ****}
                                  iconsound(1);
                                  inc(player[no].score,10);
                                  inc(player[no].levscore,10);
                                  dec(levelpoints,10);
                                  if (speed[no]>4) and (speedupcount[no]=0) then dec(speed[no],5);
                                  inc(speedupcount[no],182);
                           end;
                           2:begin  {***  Decrease speed for 10 secs  ****}
                                  iconsound(2);
                                  inc(player[no].score,10);
                                  inc(player[no].levscore,10);
                                  dec(levelpoints,10);
                                  if slowdowncount[no]=0 then inc(speed[no],5);
                                  inc(slowdowncount[no],182);
                           end;
                           3:begin  {***  10 Super Shots  ****}
                                  iconsound(3);
                                  inc(player[no].score,10);
                                  inc(player[no].levscore,10);
                                  dec(levelpoints,10);
                                  if player[no].supershots<246 then inc(player[no].supershots,10);
                           end;
                           4:begin  {***  10 Mega Shots  ****}
                                  iconsound(4);
                                  inc(player[no].score,10);
                                  inc(player[no].levscore,10);
                                  dec(levelpoints,10);
                                  if player[no].megashots<246 then inc(player[no].megashots,10);
                           end;
                           5:begin  {***  Points for moving  ***}
                                  iconsound(5);
                                  inc(mpointscount[no],182);
                           end;
                           6:begin  {***  Extra Life  ****}
                                  iconsound(6);
                                  inc(player[no].score,20);
                                  inc(player[no].levscore,20);
                                  dec(levelpoints,20);
                                  if player[no].lives<10 then inc(player[no].lives) else
                                  begin
                                       inc(player[no].score,500);
                                       inc(player[no].levscore,500);
                                       dec(levelpoints,500);
                                       update_score:=true;
                                  end;
                                  disp_lives(no);
                           end;
                           7:begin  {***  Halves worm length  ****}
                                  iconsound(7);
                                  ico:=(player[no].len+player[no].tailhold) div 2;
                                  if ico>1 then
                                  begin
                                       inc(player[no].tailcount,ico);
                                       player[no].tailspeed:=2;
                                  end;
                                  inc(player[no].score,10);
                                  inc(player[no].levscore,10);
                                  dec(levelpoints,10);
                                  ico:=0;
                           end;
                           8:begin  {***  Double worm length  ****}
                                  iconsound(8);
                                  ico:=player[no].len+player[no].tailhold;
                                  inc(player[no].tailhold,ico);
                                  inc(player[no].score,ico*20);
                                  inc(player[no].levscore,ico*20);
                                  dec(levelpoints,ico*20);
                                  ico:=0;
                           end;
                           9:begin  {***  5 Three-way Shots  ***}
                                  iconsound(9);
                                  inc(player[no].score,10);
                                  inc(player[no].levscore,10);
                                  dec(levelpoints,10);
                                  if player[no].threeway<251 then inc(player[no].threeway,5);
                           end;
                           10:begin  {***  1x Auto-Save  ***}
                                   iconsound(10);
                                   inc(player[no].score,15);
                                   inc(player[no].levscore,15);
                                   dec(levelpoints,15);
                                   if player[no].saveyou<255 then inc(player[no].saveyou);
                           end;
                           11:begin  {***  Allows 10 worm segs to be eaten  ***}
                                   iconsound(11);
                                   inc(player[no].score,15);
                                   inc(player[no].levscore,15);
                                   dec(levelpoints,15);
                                   if player[no].eats<246 then inc(player[no].eats,10);
                           end;
                           12:begin  {***  Stun other players for 10 secs  ***}
                                   if priority<=sp_stun then
                                   begin
                                        priority:=sp_stun;
                                        worm_theme;
                                   end;
                                   powercol[no]:=8;
                                   dec(levelpoints,20);
                                   zeropowercol[no]:=182;
                                   inc(player[no].score,20);
                                   inc(player[no].levscore,20);
                                   for ico:=1 to 3 do if (ico<>no) and (wormmoving[ico] or (stuncount[ico]>0)) then
                                   begin
                                        wormmoving[ico]:=false;
                                        inc(stuncount[ico],182);
                                   end;
                                   ico:=0;
                           end;
                           13..19:begin  {***  Change worm colour  ***}
                                       iconsound(ico);
                                       player[no].col:=ico-12;
                                       inc(player[no].score,5);
                                       inc(player[no].levscore,5);
                                       dec(levelpoints,5);
                           end;
                           21:begin  {***  Super power!!!  ***}
                                   if priority<=sp_stun then
                                   begin
                                        priority:=sp_stun;
                                        addnote(82,0,true);
                                        addnote(104,0,false);
                                        addnote(123,0,false);
                                        addnote(164,0,false);
                                        addnote(207,0,false);
                                        addnote(246,0,false);
                                        addnote(329,0,false);
                                        addnote(414,0,false);
                                        addnote(493,0,false);
                                        addnote(658,0,false);
                                        addnote(829,0,false);
                                        addnote(985,0,false);
                                        addnote(1315,0,false);
                                        addnote(1657,0,false);
                                        addnote(1971,0,false);
                                        addnote(2631,0,false);
                                        addnote(1971,0,false);
                                        addnote(1657,0,false);
                                        addnote(1315,0,false);
                                        addnote(985,0,false);
                                        addnote(829,0,false);
                                        addnote(658,0,false);
                                        addnote(493,0,false);
                                        addnote(414,0,false);
                                        addnote(329,0,false);
                                        addnote(246,0,false);
                                        addnote(207,0,false);
                                        addnote(164,0,false);
                                        addnote(123,0,false);
                                        addnote(104,0,false);
                                        addnote(82,0,false);
                                   end;
                                   slowdowncount[no]:=0;
                                   speedupcount[no]:=0;
                                   speedstore[no]:=playerspeed*2;
                                   speed[no]:=0;
                                   powercol[no]:=9;
                                   inc(invcount[no],182);
                                   dec(levelpoints,20);
                                   zeropowercol[no]:=182;
                                   inc(supercount[no],182);
                                   inc(player[no].score,20);
                                   inc(player[no].levscore,20);
                           end;
                           22:begin  {***  Theif (Nick other worms tails and add them to yours  ***}
                                   iconsound(22);
                                   nick_it;
                                   dec(levelpoints,20);
                                   inc(player[no].score,20);
                                   inc(player[no].levscore,20);
                           end;
                           23:begin  {***  Random blocks (Between 10 and 30 of them!) + 3 sec. invincibility for you  ***}
                                   iconsound(23);
                                   invcount[no]:=55;
                                   dec(levelpoints,100);
                                   inc(player[no].score,100);
                                   inc(player[no].levscore,100);
                                   random_blocks;
                           end;
                           24:begin  {***  Invincibility for 10 secs  ***}
                                   iconsound(24);
                                   powercol[no]:=10;
                                   inc(invcount[no],182);
                                   inc(eatcount[no],182);
                                   dec(levelpoints,20);
                                   zeropowercol[no]:=182;
                                   inc(player[no].score,20);
                                   inc(player[no].levscore,20);
                           end;
                      end;
                      if ico<>5 then
                      begin
                           update_levelp:=true;
                           update_score:=true;
                      end;
                      inc(player[no].noicons);
                 end;
                 icon[loop].howlong:=round((random(iconoffscreen)+1)*18.2);
                 icon[loop].doaction:=false;
                 icon[loop].action:=1;
            end;
end;

{Computer control module based on auto-pilot v1.2 routine from Wiggly Worm v1.4}
procedure computer_control(no:byte);
var loop,index,direct,counter,newdir:byte;
    wrong:boolean;

{Change current direction}
procedure change_direct;
begin
     if direct=1 then
     begin
          inc(newdir);
          if newdir>4 then newdir:=1;
     end else
     begin
          dec(newdir);
          if newdir<1 then newdir:=4;
     end;
end;

{Make sure worm isn't going to crash}
function check_worm(chkdir:byte):boolean;
begin
     with player[no] do
     begin
          check_worm:=true;
          case chkdir of  {***  Make sure worm is not going to turn back on itself  ***}
               1:if dir=3 then check_worm:=false;
               2:if dir=4 then check_worm:=false;
               3:if dir=1 then check_worm:=false;
               4:if dir=2 then check_worm:=false;
          end;
          case chkdir of  {***  Make sure worm isn't going to hit itself or a wall  ***}
               1:if (screen[head.x,head.y-1] in [1,3]) and ((eats=0) and (eatcount[no]=0)) then
                    check_worm:=false;
               2:if (screen[head.x+1,head.y] in [1,3]) and ((eats=0) and (eatcount[no]=0)) then
                    check_worm:=false;
               3:if (screen[head.x,head.y+1] in [1,3]) and ((eats=0) and (eatcount[no]=0)) then
                    check_worm:=false;
               4:if (screen[head.x-1,head.y] in [1,3]) and ((eats=0) and (eatcount[no]=0)) then
                    check_worm:=false;
          end;
          case chkdir of  {***  Make sure worm isn't going to hit edge of screen  ***}
               1:if screen[head.x,head.y-1]=2 then check_worm:=false;
               2:if screen[head.x+1,head.y]=2 then check_worm:=false;
               3:if screen[head.x,head.y+1]=2 then check_worm:=false;
               4:if screen[head.x-1,head.y]=2 then check_worm:=false;
          end;
     end;
end;

begin
     with player[no] do
     begin
          index:=1;
          key[no].fire:=false;
          while (index<=maxicons) and (complist[index].nearest<>no) do inc(index);
          if index>maxicons then index:=1;
          if complist[index].iconno<>0 then
          begin
               gx:=icon[complist[index].iconno].x;
               gy:=icon[complist[index].iconno].y;
          end;
          direct:=random(2);
          newdir:=dir;
          if not (newdir in [1..4]) then newdir:=1;
          {***  Find out what direction the worm needs to go in to get to the icon  ***}
          if (gx<head.x) and check_worm(4) then newdir:=4;
          if (gx>head.x) and check_worm(2) then newdir:=2;
          if (gy<head.y) and check_worm(1) then newdir:=1;
          if (gy>head.y) and check_worm(3) then newdir:=3;
          counter:=0;
          while (counter<4) and wrong do
          begin
               wrong:=true;
               if check_worm(newdir) then wrong:=false else change_direct;
               inc(counter);
          end;
          {***  Makes computer players make a "mistake" every so often  ***}
          if wrong and computerlaser and (supercount[no]=0) then
             if player[no].levscore-player[no].lastscore>50 then
                if random(100)<computerability then wrong:=false;
          if wrong and (computerlaser or (supercount[no]>0)) then
          begin
               counter:=0;
               while (counter<4) and wrong do
               begin
                    wrong:=true;
                    {***  Try to make worm go in a direction where they can use the laser to save themselves  ***}
                    case newdir of
                         1:if not (screen[head.x,head.y-1] in [2,3]) then wrong:=false;
                         2:if not (screen[head.x+1,head.y] in [2,3]) then wrong:=false;
                         3:if not (screen[head.x,head.y+1] in [2,3]) then wrong:=false;
                         4:if not (screen[head.x-1,head.y] in [2,3]) then wrong:=false;
                    end;
                    if wrong then change_direct;
                    inc(counter);
               end;
               if not wrong then key[no].fire:=true;
          end;
          key[no].dir:=newdir;
          if stuncount[no]=0 then wormmoving[no]:=true;
     end;
end;

{Calculate icon priorities (Which icon should each computer player go for?)}
procedure calculate_priorities;
var distx,disty:array[1..3] of byte;
    loop,loop2,index,pri:word;

begin
     {***  Clear icon priority list  ***}
     for loop:=1 to maximumicons do with complist[loop] do
     begin
          priority:=0;
          nearest:=0;
          iconno:=0;
     end;
     {***  Sort icons in order of priority  ***}
     for loop:=1 to maxicons do if icon[loop].action=2 then
     begin
          index:=1;
          if icon[loop].numb then pri:=numbpriority[icon[loop].itype] else
             pri:=iconpriority[icon[loop].itype];
          while (pri<complist[index].priority) and (index<=maxicons) do inc(index);
          if index+1<maximumicons then for loop2:=maximumicons downto index+1 do
             complist[loop2]:=complist[loop2-1];
          with complist[index] do
          begin
               iconno:=loop;
               priority:=pri;
          end;
     end;
     {***  Calculate nearest player  ***}
     for loop:=1 to maxicons do if complist[loop].iconno>0 then
         with complist[loop] do if icon[iconno].action=2 then
         begin
              {***  Calculate distance of each player from icon  ***}
              for loop2:=1 to 3 do if player[loop2].ptype>0 then
              begin
                   if icon[iconno].x>player[loop2].head.x then
                      distx[loop2]:=icon[iconno].x-player[loop2].head.x else
                         distx[loop2]:=player[loop2].head.x-icon[iconno].x;
                   if icon[iconno].y>player[loop2].head.y then
                      disty[loop2]:=icon[iconno].y-player[loop2].head.y else
                         disty[loop2]:=player[loop2].head.y-icon[iconno].y;
              end else
              begin
                   distx[loop2]:=255;
                   disty[loop2]:=255;
              end;
              {***  Work out which player is nearest  ***}
              if (player[1].ptype>0) and (player[1].lives>0) then nearest:=1 else
                 if (player[2].ptype>0) and (player[2].lives>0) then nearest:=2 else
                    nearest:=3;
              for loop2:=1 to 3 do if (distx[loop2]<=distx[nearest]) and (disty[loop2]<=disty[nearest]) then
                  nearest:=loop2;
         end;
end;

{Calculate directions of laser and worm segments/walls/worms that get destroyed by it}
procedure calculate_laser(no:byte);
var loop:byte;

{Has worm NO shot an icon?}
procedure laser_icon(no,lno:byte);
var loop,ico:word;
begin
     for loop:=1 to maxicons do
         if (laser[no,lno].x2=icon[loop].x) and (laser[no,lno].y2=icon[loop].y) then
         begin
              ico:=icon[loop].itype;
              if icon[loop].numb then
              begin
                   case ico of
                        0:dec(player[no].score,(random(51)+25)*10);
                        1..9:dec(player[no].score,ico*10);
                        15,14:dec(player[no].score,1000);
                        11:dec(player[no].score,100);
                        12:dec(player[no].score,250);
                        13:dec(player[no].score,500);
                        10:inc(player[no].score,5);
                   end;
              end else
              begin
                   if ico=20 then repeat ico:=random_icon; until ico<>20;
                   case ico of
                        8:dec(player[no].score,300);
                        3:dec(player[no].score,150);
                        6:dec(player[no].score,1000);
                        10:dec(player[no].score,100);
                        22:dec(player[no].score,300);
                        21:dec(player[no].score,500);
                        5,24:dec(player[no].score,400);
                        1,2,7:dec(player[no].score,50);
                        11,12:dec(player[no].score,200);
                        4,9,13,23:dec(player[no].score,50);
                   end;
              end;
              icon[loop].howlong:=round((random(iconoffscreen)+1)*18.2);
              icon[loop].doaction:=false;
              icon[loop].action:=1;
         end;
end;

{Clear path in direction of laser LNO}
procedure laser_path(lno:byte);
var nofurther,wormseg:boolean;
    x3,y3,loop:byte;

begin
     with laser[no,lno] do
     begin
          setfillstyle(1,black);
          nofurther:=false;
          wormseg:=false;
          repeat
                x3:=x2; y3:=y2;
                case dir of
                     1:if y2>1 then dec(y2) else nofurther:=true;
                     2:if x2<78 then inc(x2) else nofurther:=true;
                     3:if y2<55 then inc(y2) else nofurther:=true;
                     4:if x2>1 then dec(x2) else nofurther:=true;
                     else nofurther:=true;
                end;
                if not nofurther and (screen[x2,y2]=3) and (lasertype[no]<2) then
                begin
                     nofurther:=true;
                     x2:=x3; y2:=y3;
                end;
                if not nofurther and (screen[x2,y2]=1) and (lasertype[no]=0) then nofurther:=true;
                if not ((x2=x1) and (y2=y1)) then
                begin
                     if screen[x2,y2]=4 then laser_icon(no,lno) else
                        if laserkills then for loop:=1 to 3 do if loop<>no then
                           if (x2=player[loop].head.x) and (y2=player[loop].head.y) then
                              if wormmoving[loop] and (player[loop].deadcount=0) then
                                 if player[loop].levscore-player[loop].lastscore>50 then
                                 begin
                                      inc(player[no].score,100);
                                      inc(player[no].levscore,100);
                                      dec(levelpoints,100);
                                      worm_dead(loop);
                                 end;
                     bar(x2*8,(y2+3)*8,(x2*8)+7,((y2+3)*8)+7);
                     screen[x2,y2]:=0;
                end;
          until nofurther;
     end;
end;

begin
     with player[no] do
     begin
          if megashots>0 then
          begin
               dec(megashots);
               lasertype[no]:=2;
          end else if supershots>0 then
          begin
               dec(supershots);
               lasertype[no]:=1;
          end else lasertype[no]:=0;
          if threeway>0 then
          begin
               dec(threeway);
               laser3way[no]:=true;
          end else laser3way[no]:=false;
          for loop:=1 to 3 do
          begin
               laser[no,loop].x1:=head.x;
               laser[no,loop].y1:=head.y;
               laser[no,loop].x2:=head.x;
               laser[no,loop].y2:=head.y;
               laser_onscreen[no]:=true;
               laser[no,loop].dir:=lastdir[no];
          end;
          laser[no,2].dir:=turntable[dir,1];
          laser[no,3].dir:=turntable[dir,2];
          laser_path(1);
          if laser3way[no] then
          begin
               laser_path(2);
               laser_path(3);
          end;
          dec(player[no].score,5);
          update_score:=true;
          if priority<=sp_fire then
          begin
               priority:=sp_fire;
               addnote(7000,0,true);
               addnote(6900,0,false);
               addnote(6800,0,false);
               addnote(6700,0,false);
               addnote(6600,0,false);
          end;
     end;
end;

{Draw laser beam(s)}
procedure draw_laser(no,lno:byte);
begin
     case lasertype[no] of
          0:setcolor(white);
          1:setcolor(yellow);
          2:setcolor(lightred);
     end;
     with laser[no,lno] do if not ((x1=x2) and (y1=y2)) then case dir of
          1:begin
                 line((x2*8)+3,(y2+3)*8,(x1*8)+3,((y1+2)*8)+7);
                 case lasertype[no] of
                      0:setcolor(lightgray);
                      1:setcolor(brown);
                      2:setcolor(red);
                 end;
                 line((x2*8)+4,(y2+3)*8,(x1*8)+4,((y1+2)*8)+7);
          end;
          2:begin
                 line((x1+1)*8,((y1+3)*8)+3,(x2*8)+7,((y2+3)*8)+3);
                 case lasertype[no] of
                      0:setcolor(lightgray);
                      1:setcolor(brown);
                      2:setcolor(red);
                 end;
                 line((x1+1)*8,((y1+3)*8)+4,(x2*8)+7,((y2+3)*8)+4);
          end;
          3:begin
                 line((x1*8)+3,(y1+4)*8,(x2*8)+3,((y2+3)*8)+7);
                 case lasertype[no] of
                      0:setcolor(lightgray);
                      1:setcolor(brown);
                      2:setcolor(red);
                 end;
                 line((x1*8)+4,(y1+4)*8,(x2*8)+4,((y2+3)*8)+7);
          end;
          4:begin
                 line(x2*8,((y2+3)*8)+3,((x1-1)*8)+7,((y1+3)*8)+3);
                 case lasertype[no] of
                      0:setcolor(lightgray);
                      1:setcolor(brown);
                      2:setcolor(red);
                 end;
                 line(x2*8,((y2+3)*8)+4,((x1-1)*8)+7,((y1+3)*8)+4);
          end;
     end;
end;

{Remove laser beam(s)}
procedure remove_laser(no:byte);
var loop:byte;

{Remove laser beam LNO of player NO}
procedure remove_beam(no,lno:byte);
var low,high,loop:byte;
begin
     setfillstyle(1,black);
     with laser[no,lno] do case dir of
          1,3:begin
                   if y1<y2 then
                   begin
                        low:=y1;
                        high:=y2;
                   end else
                   begin
                        low:=y2;
                        high:=y1;
                   end;
                   for loop:=low to high do if screen[x1,loop]=0 then
                       bar(x1*8,(loop+3)*8,(x1*8)+7,((loop+3)*8)+7) else
          end;
          2,4:begin
                   if x1<x2 then
                   begin
                        low:=x1;
                        high:=x2;
                   end else
                   begin
                        low:=x2;
                        high:=x1;
                   end;
                   for loop:=low to high do if screen[loop,y1]=0 then
                       bar(loop*8,(y1+3)*8,(loop*8)+7,((y1+3)*8)+7) else
          end;
     end;
end;

begin
     for loop:=1 to 3 do
     begin
          if laser_onscreen[loop] then
          begin
               remove_beam(loop,1);
               if laser3way[loop] then
               begin
                    remove_beam(loop,2);
                    remove_beam(loop,3);
               end;
               laser_onscreen[loop]:=false;
               key[loop].fire:=false;
          end;
     end;
end;

{Display hiscore table}
procedure display_hiscores(pdel:boolean);
var loop,fg,bg:byte;
    pstr:string[3];

begin
     clear_playing_field;
     grafxy(1,57);
     if pdel then grafcent('Press DEL to clear high-scores or any other key to continue...',lightmagenta,magenta) else
        grafcent('High-scores cleared - press any key to continue...',lightmagenta,magenta);
     grafxy(1,4);
     grafcentln9('- The TOP 40 totally excellent Wiggly Wormers! -',lightgreen,green);
     grafln;
     grafcentln9('                                        LEVEL  SPEED        NUMBERS         ',lightmagenta,magenta);
     grafcentln9(#25+'     '+#25+'                          '+#25+'          '+#25+'    '+#25+'   '+
                  #25+'      '+#25+'      '+#25+'        ',white,lightgray);
     grafxy(gf.x,gf.y-1);
     grafcentln9(' RANK  NAME                       SCORE               ICONS         MAX LEN.',lightmagenta,magenta);
     grafcentln9('',lightred,red);
     loop:=40;
     repeat
           addnote(20+(41-loop),10,true);
           grafxy(1,loop+8);
           del:=1;
           if loop=1 then
           begin
                if (player[1].head.dir=loop) or (player[2].head.dir=loop) or (player[3].head.dir=loop) then
                begin
                     if player[1].head.dir=loop then pstr:=#27+' 1' else
                        if player[2].head.dir=loop then pstr:=#27+' 2' else
                           if player[3].head.dir=loop then pstr:=#27+' 3';
                     fg:=white;
                     bg:=lightgray;
                end else
                begin
                     fg:=lightcyan;
                     pstr:='   ';
                     bg:=cyan;
                end;
           end else
           begin
                if (player[1].head.dir=loop) or (player[2].head.dir=loop) or (player[3].head.dir=loop) then
                begin
                     if player[1].head.dir=loop then pstr:=#27+' 1' else
                        if player[2].head.dir=loop then pstr:=#27+' 2' else
                           if player[3].head.dir=loop then pstr:=#27+' 3';
                     fg:=lightcyan;
                     bg:=cyan;
                end else
                begin
                     fg:=lightblue;
                     pstr:='   ';
                     bg:=blue;
                end;
           end;
           with hiscore[loop] do grafcentln9(trunc_str(rank(loop),6)+
                trunc_str(name,27)+trunc_str(convert(score),11)+
                trunc_str(convert(level),5)+trunc_str(convert(speed),4)+
                trunc_str(convert(noicons),7)+trunc_str(convert(numbers),7)+
                trunc_str(convert(maxlen),6)+pstr,fg,bg);
           dec(loop);
           repeat until del=0;
     until (loop=0) or escape;
     addnote(0,0,true);
end;

{Play music after displaying hiscores}
procedure hiscore_music;
begin
     addnote(0,4,true);
     addchord(391,196,false);
     addchord(391,196,false);
     addchord(391,196,false);
     addchord(494,238,false);
     addchord(391,238,false);
     addchord(494,250,false);
     addchord(781,196,false);
     addchord(781,196,false);
     addchord(781,196,false);
     addchord(391,238,false);
     addchord(391,238,false);
     addchord(391,250,false);
     addchord(293,186,false);
     addchord(293,186,false);
     addchord(293,186,false);
     addchord(373,262,false);
     addchord(293,262,false);
     addchord(373,293,false);
     addchord(587,186,false);
     addchord(587,186,false);
     addchord(587,186,false);
     addchord(293,262,false);
     addchord(293,262,false);
     addchord(293,293,false);
     addchord(391,98,false);
     addchord(293,98,false);
     addchord(250,98,false);
     addchord(196,98,false);
     addchord(196,98,false);
     addchord(196,98,false);
     repeat until (qpos>qlen) or escape;
end;

{View hiscore table}
procedure view_hiscores(music:boolean);
var oldmr:boolean;
begin
     ky:=#255;
     escape:=false;
     oldmr:=mrepeat;
     mrepeat:=false;
     display_hiscores(true);
     if music then hiscore_music;
     if not escape then
     begin
          if mouseon then repeat until get_mousebutt=0;
          repeat
                if mouseon and (get_mousebutt>0) then escape:=true;
                if keypressed then
                begin
                     ky:=readkey;
                     if ky=#0 then
                     begin
                          ky:=readkey;
                          if ky<>#83 then ky:=#255 else ky:=#8;
                     end;
                     if ky=#8 then
                     begin
                          addnote(781,0,true);
                          addnote(587,0,false);
                          addnote(494,0,false);
                          addnote(391,0,false);
                          player[1].head.dir:=0;
                          player[2].head.dir:=0;
                          player[3].head.dir:=0;
                          repeat until qpos>qlen;
                          clear_hiscore;
                          save_hiscore;
                          display_hiscores(false);
                          ky:=#255;
                     end;
                end;
          until (not (ky in [#8,#255]) and not escape) or escape;
          if mouseon then repeat until get_mousebutt=0;
     end;
     selectsound;
     repeat until qpos>qlen;
     mrepeat:=oldmr;
     escape:=false;
     ky:=#255;
end;

{Gets key press off key press buffer for a player}
function buffer_get(no:byte):byte;
begin
     if bufhead[no]<>buftail[no] then
     begin
          buffer_get:=keybuffer[no,buftail[no]];
          inc(buftail[no]);
          if buftail[no]>keybuffersize then buftail[no]:=1;
     end else buffer_get:=key[no].dir;
end;

{Play a game of Wiggly Worm!}
procedure game;
var loop,loop2:word;
begin
     mrepeat:=false;
     clear;
     disp_score(1); disp_lives(1);
     disp_score(2); disp_lives(2);
     disp_score(3); disp_lives(3);
     repeat
           levbonus:=false;
           clear_playing_field;
           startoflevel(true);
           clear_before_level;
           if level>1 then for loop:=2 to level do draw_walls;
           worms_left:=0;
           for loop:=1 to 3 do if (worm_playing(loop)) and not player[loop].dead then
           begin
                randomize_wormpos(loop);
                screen[player[loop].head.x,player[loop].head.y]:=1;
                scrtail[player[loop].head.x,player[loop].head.y,loop]:=1;
                player[loop].gx:=player[loop].head.x;
                player[loop].gy:=player[loop].head.y;
                display_worm(loop,false,false);
                inc(worms_left);
           end;
           repeat
                 delay(2);
                 remove_laser(loop);
                 update_levelp:=false;
                 asm
                    cmp WORD PTR update[0],0
                    je  @update2
                    dec WORD PTR update[0]
           @update2:cmp WORD PTR update[2],0
                    je  @update3
                    dec WORD PTR update[2]
           @update3:cmp WORD PTR update[4],0
                    je  @updateend
                    dec WORD PTR update[4]
         @updateend:
                 end;
                 calculate_priorities;
                 for loop:=1 to maximumicons do with icon[loop] do if doaction then
                     case action of
                          1:begin  {***  Display new icon/number  ***}
                                 if random(20)<iconprobability then
                                 begin
                                      numb:=false;
                                      itype:=random_icon;
                                 end else
                                 begin
                                      numb:=true;
                                      itype:=random(14);
                                 end;
                                 repeat
                                       x:=random(78)+1;
                                       y:=random(55)+1;
                                 until (screen[x,y]=0);
                                 screen[x,y]:=4;
                                 if numb then putimage(x*8,(y+3)*8,numbs^[itype],normalput) else
                                    putimage(x*8,(y+3)*8,icons^[itype],normalput);
                                 howlong:=round((random(icononscreen)+1)*18.2);
                                 doaction:=false;
                                 action:=2;
                          end;
                          2:begin  {***  Remove icon/number from screen  ***}
                                 if screen[x,y]=4 then
                                 begin
                                      setfillstyle(1,black);
                                      bar(x*8,(y+3)*8,(x*8)+7,((y+3)*8)+7);
                                      screen[x,y]:=0;
                                 end;
                                 howlong:=round((random(iconoffscreen)+1)*18.2);
                                 doaction:=false;
                                 action:=1;
                          end;
                     end;
                 for loop:=1 to 3 do if not (player[loop].dead and (player[loop].deadcount=0)) and (update[loop]=0) then
                 begin
                      if (player[loop].len<2) and (wormmoving[loop]) then
                      begin
                           loop:=loop;
                      end;
                      key[loop].dir:=buffer_get(loop);
                      update[loop]:=speed[loop];
                      update_score:=false;
                      if (player[loop].ptype=computer) or (supercount[loop]>1) then
                         computer_control(loop);
                      {***  Update current direction of worm  ***}
                      with player[loop] do if not player[loop].dead and (deadcount=0) then
                      begin
                           case key[loop].dir of
                                1:begin
                                       if dir<>1 then
                                       begin
                                            dir:=1;
                                            change_dir(loop);
                                       end else dir:=1;
                                       lastdir[loop]:=1;
                                       display_worm(loop,false,false);
                                       key[loop].dir:=0;
                                end;
                                2:begin
                                       if dir<>2 then
                                       begin
                                            dir:=2;
                                            change_dir(loop);
                                       end else dir:=2;
                                       lastdir[loop]:=2;
                                       display_worm(loop,false,false);
                                       key[loop].dir:=0;
                                end;
                                3:begin
                                       if dir<>3 then
                                       begin
                                            dir:=3;
                                            change_dir(loop);
                                       end else dir:=3;
                                       lastdir[loop]:=3;
                                       display_worm(loop,false,false);
                                       key[loop].dir:=0;
                                end;
                                4:begin
                                       if dir<>4 then
                                       begin
                                            dir:=4;
                                            change_dir(loop);
                                       end else dir:=4;
                                       lastdir[loop]:=4;
                                       display_worm(loop,false,false);
                                       key[loop].dir:=0;
                                end;
                           end;
                      end;

                      {***  Move worm, detect collisions, etc.  ***}
                      if (wormmoving[loop]) and (player[loop].deadcount=0) and (stuncount[loop]=0) and not pause then
                      begin
                           if (key[loop].fire) and (player[loop].score>0) then
                           begin
                                if ((player[loop].ptype=human) and humanlaser) or
                                   ((player[loop].ptype=computer) and computerlaser) then
                                      calculate_laser(loop) else key[loop].fire:=false;
                           end else key[loop].fire:=false;

                           if player[loop].lives>0 then
                           begin
                                display_worm(loop,false,true);
                                move_worm(loop);
                           end else temp:=player[loop].head;
                           test_collision(loop);
                           test_icon(loop);

                           if (key[loop].fire) and (player[loop].score>0) then
                           begin
                                draw_laser(loop,1);
                                if laser3way[loop] then
                                begin
                                     draw_laser(loop,2);
                                     draw_laser(loop,3);
                                end;
                           end;

                           if (wormmoving[loop]) and (player[loop].deadcount=0) then
                           begin
                                {***  Points for moving?  ***}
                                with player[loop] do if not ((head.x=temp.x) and (head.y=temp.y)) and
                                     (mpointscount[loop]>0) then
                                     begin
                                          inc(score,level);
                                          inc(levscore,level);
                                          dec(levelpoints,level);
                                          if ((level and 1=0) and (score and 2<>0)) or
                                             ((level and 1<>0) and (score and 1<>0)) then
                                             begin
                                                  update_levelp:=true;
                                                  update_score:=true;
                                             end;
                                     end;
                                if player[loop].lives>0 then player[loop].head:=temp;
                                display_worm(loop,true,false);
                                move_tail(loop);
                           end;
                      end else if stuncount[loop]=0 then
                      begin
                           display_worm(loop,false,false);
                           with player[loop] do if deadcount>0 then
                           begin
                                if priority<=sp_dead then
                                begin
                                     priority:=sp_dead;
                                     addnote(random(30)+20,1,true);
                                end;
                                dec(deadcount);
                                if lives=0 then
                                begin
                                     if len>1 then dec(len) else deadcount:=0;
                                end else
                                begin
                                     if len>3 then dec(len) else deadcount:=0;
                                     if len<3 then len:=2;
                                end;
                                if (deadcount=0) then
                                begin
                                     wormmoving[loop]:=false;
                                     if player[loop].dead then
                                     begin
                                          if priority<=sp_nolives then
                                          begin
                                               priority:=sp_nolives;
                                               addnote(131,3,true);
                                               addnote(0,0,false);
                                               addnote(131,2,false);
                                               addnote(0,0,false);
                                               addnote(131,0,false);
                                               addnote(0,0,false);
                                               addnote(131,3,false);
                                               addnote(0,0,false);
                                               addnote(156,2,false);
                                               addnote(0,0,false);
                                               addnote(147,0,false);
                                               addnote(0,0,false);
                                               addnote(147,2,false);
                                               addnote(0,0,false);
                                               addnote(131,0,false);
                                               addnote(0,0,false);
                                               addnote(131,2,false);
                                               addnote(0,0,false);
                                               addnote(123,0,false);
                                               addnote(0,0,false);
                                               addnote(131,3,false);
                                               addnote(0,0,false);
                                          end;
                                          dec(worms_left);
                                     end;
                                end;
                                move_tail(loop);
                           end;
                      end else key[loop].dir:=0;
                      if player[loop].len>player[loop].maxlen then
                         player[loop].maxlen:=player[loop].len;
                      if update_score then disp_score(loop);
                      if player[loop].score>=nextlife[loop] then
                      begin
                           priority:=sp_icon;
                           addnote(131,0,true);
                           addnote(165,0,false);
                           addnote(196,0,false);
                           addnote(262,0,false);
                           addnote(333,0,false);
                           addnote(391,0,false);
                           addnote(524,0,false);
                           if player[loop].lives<10 then inc(player[loop].lives) else
                           begin
                                inc(player[loop].score,500);
                                inc(player[loop].levscore,500);
                                dec(levelpoints,500);
                                update_score:=true;
                           end;
                           disp_lives(loop);
                           inc(nextlife[loop],10000);
                      end;
                 end;
                 if update_levelp then disp_levelpoints;
           until escape or (worms_left=0) or (levelpoints<=0);
           if not escape then
           begin
                if levelpoints<0 then levelpoints:=0;
                disp_levelpoints;
                if worms_left=0 then endoflevel(1) else
                   endoflevel(0);
           end;
     until escape or (worms_left=0);
     if not boss then
     begin
          for loop:=1 to 3 do player[loop].head.dir:=0;
          escape:=false;
          for loop:=1 to 3 do player[loop].dead:=false;
          if not levbonus then endoflevel(2);
          for loop:=1 to 3 do if player[loop].ptype>0 then rank_player(loop);
          for loop:=1 to 3 do if player[loop].ptype>0 then
          begin
               if not boss then
               begin
                    escape:=false;
                    player_hiscore(loop);
               end;
          end;
          save_hiscore;
          if not boss then
          begin
               escape:=false;
               view_hiscores(true);
          end;
     end;
end;

{Draw main (Menu) screen}
procedure draw_mainscreen(bdclear,clear:boolean);
begin
     border(bdclear);

     if clear then
     begin
          {***  Copyright and all time champion display  ***}
          grafxy(1,57);
          grafcent('Written by J.P.Boggis 24/01/1994 - '+verdate,lightgray,darkgray);
          grafxy(1,5);
          grafcent('All time champion:  '+trunc_str('',length(hiscore[1].name))+' with a score of '+trunc_str('',
                   length(convert(hiscore[1].score))),lightgreen,green);
          grafcent('                    '+hiscore[1].name+'                 '+trunc_str('',length(convert(
                   hiscore[1].score))),white,lightgray);
          grafcentln('                    '+trunc_str('',length(hiscore[1].name))+'                 '+convert(hiscore[1].
                     score),lightcyan,cyan);

          {***  Wiggly Worm '94 title  ***}
          putimage(41,57,wormtitle^,normalput);
          grafxy(62,13);
          graftext('Special Edition',lightmagenta,magenta);
     end;

     {***  Buttons  ***}
     setcolor(lightgray);
     rectangle(20,mpos-9,621,mpos+317);
     setcolor(white);
     rectangle(19,mpos-10,620,mpos+316);
     setcolor(lightblue);
     rectangle(22,mpos-7,618,mpos+314);
     setfillstyle(1,blue);
     bar(23,mpos-6,617,mpos+313);
     refreshbutt:=true;
     draw_button(0,2);
     refreshbutt:=false;
end;

{Does initial setup and allows editing of parameters/starting of game}
procedure main;
var continue:boolean;
begin
     setup;
     load_hiscore;
     load_configuration;
     if mouse_installed then mouseon:=true else mouseon:=false;
     draw_license_screen(true);
     if not boss then draw_mainscreen(false,false);
     if mouseon then mouse_curs(on);
     repeat
           both:=false;
           special:=false;
           if mouseon then mouse_test;
           if keypressed then
           begin
                ky:=upcase(readkey);
                if ky=#0 then
                begin
                     ky:=readkey;
                     case ky of
                          #45:ky:='Q';
                     end;
                     if not (ky in ['Q']) then ky:=#255;
                end;
                if ky<>#255 then case ky of
                   '1','!':  {***  Change player 1's controller (Not playing, human, computer)  ***}
                   begin
                        draw_button(10,1);
                        del:=2;
                        repeat until del=0;
                        if both then player[1].ptype:=human else if special then
                        begin
                             if player[1].ptype>0 then dec(player[1].ptype) else
                                player[1].ptype:=2;
                        end else if player[1].ptype<2 then inc(player[1].ptype) else
                            player[1].ptype:=0;
                        draw_button(10,2);
                   end;
                   '2','"':  {***  Change player 2's controller (Not playing, human, computer)  ***}
                   begin
                        draw_button(11,1);
                        del:=2;
                        repeat until del=0;
                        if both then player[2].ptype:=computer else if special then
                        begin
                             if player[2].ptype>0 then dec(player[2].ptype) else
                                player[2].ptype:=2;
                        end else if player[2].ptype<2 then inc(player[2].ptype) else
                            player[2].ptype:=0;
                        draw_button(11,2);
                   end;
                   '3','':  {***  Change player 3's controller (Not playing, human, computer)  ***}
                   begin
                        draw_button(12,1);
                        del:=2;
                        repeat until del=0;
                        if both then player[3].ptype:=notplaying else if special then
                        begin
                             if player[3].ptype>0 then dec(player[3].ptype) else
                                player[3].ptype:=2;
                        end else if player[3].ptype<2 then inc(player[3].ptype) else
                            player[3].ptype:=0;
                        draw_button(12,2);
                   end;
                   'C':begin  {***  Toggle whether computer players can use laser  ***}
                            draw_button(20,1);
                            del:=2;
                            repeat until del=0;
                            if computerlaser then computerlaser:=false else computerlaser:=true;
                            if both then computerlaser:=true;
                            draw_button(20,2);
                   end;
                   'H':begin  {***  Toggle whether human players can use laser  ***}
                            draw_button(21,1);
                            del:=2;
                            repeat until del=0;
                            if humanlaser then humanlaser:=false else humanlaser:=true;
                            if both then humanlaser:=true;
                            draw_button(21,2);
                   end;
                   '-','_','+','=':  {***  Increase/decrease game speed  ***}
                   begin
                        draw_button(30,1);
                        del:=2;
                        repeat until del=0;
                        if both then playerspeed:=6 else if special or (ky in ['-','_']) then
                        begin
                             if playerspeed>0 then dec(playerspeed) else playerspeed:=99;
                        end else if (ky in ['+','=']) then if playerspeed<99 then
                            inc(playerspeed) else playerspeed:=0;
                        draw_button(30,2);
                   end;
                   'L':begin  {***  Increase/decrease game speed  ***}
                            draw_button(31,1);
                            del:=2;
                            repeat until del=0;
                            if both then playerlives:=4 else if special then
                            begin
                                 if playerlives>1 then dec(playerlives) else playerlives:=5;
                            end else if playerlives<5 then inc(playerlives) else playerlives:=1;
                            draw_button(31,2);
                   end;
                   'I':begin  {***  Change icon probability  ***}
                            draw_button(40,1);
                            del:=2;
                            repeat until del=0;
                            if both then iconprobability:=5 else
                               if special then case iconprobability of
                                  0:iconprobability:=20;
                                  2:iconprobability:=0;
                                  5:iconprobability:=2;
                                  7:iconprobability:=5;
                                  10:iconprobability:=7;
                                  13:iconprobability:=10;
                                  15:iconprobability:=13;
                                  18:iconprobability:=15;
                                  20:iconprobability:=18;
                               end else case iconprobability of
                                   0:iconprobability:=2;
                                   2:iconprobability:=5;
                                   5:iconprobability:=7;
                                   7:iconprobability:=10;
                                   10:iconprobability:=13;
                                   13:iconprobability:=15;
                                   15:iconprobability:=18;
                                   18:iconprobability:=20;
                                   20:iconprobability:=0;
                               end;
                            draw_button(40,2);
                   end;
                   'W':begin  {***  Change what happens to worm length after crashing  ***}
                            draw_button(41,1);
                            del:=2;
                            repeat until del=0;
                            if both then wormmethod:=5 else if special then
                            begin
                                 if wormmethod>1 then dec(wormmethod) else
                                    wormmethod:=10;
                            end else if wormmethod<10 then inc(wormmethod) else
                                wormmethod:=1;
                            draw_button(41,2);
                   end;
                   'D':begin  {***  Change level difficulty  ***}
                            draw_button(42,1);
                            del:=2;
                            repeat until del=0;
                            if both then levelendpoints:=1000 else
                               if special then case levelendpoints of
                                  250:levelendpoints:=3000;
                                  500:levelendpoints:=250;
                                  1000:levelendpoints:=500;
                                  1500:levelendpoints:=1000;
                                  2000:levelendpoints:=1500;
                                  3000:levelendpoints:=2000;
                               end else case levelendpoints of
                                  250:levelendpoints:=500;
                                  500:levelendpoints:=1000;
                                  1000:levelendpoints:=1500;
                                  1500:levelendpoints:=2000;
                                  2000:levelendpoints:=3000;
                                  3000:levelendpoints:=250;
                               end;
                            draw_button(42,2);
                   end;
                   'O':begin  {***  Change computer playing ability  ***}
                            draw_button(43,1);
                            del:=2;
                            repeat until del=0;
                            if both then computerability:=10 else
                               if special then case computerability of
                                  0:computerability:=1;
                                  1:computerability:=10;
                                  10:computerability:=20;
                                  20:computerability:=35;
                                  35:computerability:=50;
                                  50:computerability:=70;
                                  70:computerability:=85;
                                  85:computerability:=95;
                                  95:computerability:=100;
                                  100:computerability:=0;
                               end else case computerability of
                                  0:computerability:=100;
                                  1:computerability:=0;
                                  10:computerability:=1;
                                  20:computerability:=10;
                                  35:computerability:=20;
                                  50:computerability:=35;
                                  70:computerability:=50;
                                  85:computerability:=70;
                                  95:computerability:=85;
                                  100:computerability:=95;
                               end;
                            draw_button(43,2);
                   end;
                   'A':begin  {***  Toggle fast computer option on/off  ***}
                            draw_button(44,1);
                            del:=2;
                            repeat until del=0;
                            if fastcomputers then fastcomputers:=false else fastcomputers:=true;
                            if both then fastcomputers:=true;
                            draw_button(44,2);
                   end;
                   'N':begin  {***  Change no. secs icons stay on screen  ***}
                            draw_button(50,1);
                            del:=2;
                            repeat until del=0;
                            if both then icononscreen:=15 else
                               if special then case icononscreen of
                                  5:icononscreen:=30;
                                  10:icononscreen:=5;
                                  15:icononscreen:=10;
                                  20:icononscreen:=15;
                                  25:icononscreen:=20;
                                  30:icononscreen:=25;
                               end else case icononscreen of
                                  5:icononscreen:=10;
                                  10:icononscreen:=15;
                                  15:icononscreen:=20;
                                  20:icononscreen:=25;
                                  25:icononscreen:=30;
                                  30:icononscreen:=5;
                               end;
                            draw_button(50,2);
                   end;
                   'F':begin  {***  Change no. secs icons are off screen  ***}
                            draw_button(51,1);
                            del:=2;
                            repeat until del=0;
                            if both then iconoffscreen:=15 else
                               if special then case iconoffscreen of
                                  5:iconoffscreen:=30;
                                  10:iconoffscreen:=5;
                                  15:iconoffscreen:=10;
                                  20:iconoffscreen:=15;
                                  25:iconoffscreen:=20;
                                  30:iconoffscreen:=25;
                               end else case iconoffscreen of
                                  5:iconoffscreen:=10;
                                  10:iconoffscreen:=15;
                                  15:iconoffscreen:=20;
                                  20:iconoffscreen:=25;
                                  25:iconoffscreen:=30;
                                  30:iconoffscreen:=5;
                               end;
                            draw_button(51,2);
                   end;
                   'M':begin  {***  Change maximum number of icons on screen  ***}
                            draw_button(52,1);
                            del:=2;
                            repeat until del=0;
                            if both then maxicons:=5 else if special then
                            begin
                                 if maxicons>1 then dec(maxicons) else
                                    maxicons:=10;
                            end else if maxicons<10 then inc(maxicons) else
                                maxicons:=1;
                            draw_button(52,2);
                   end;
                   'V':begin  {***  View highscores  ***}
                            selectsound;
                            draw_button(1,1);
                            del:=2;
                            repeat until del=0;
                            if mouseon then mouse_curs(off);
                            view_hiscores(false);
                            if not boss then
                            begin
                                 clear_playing_field;
                                 draw_mainscreen(false,true);
                            end;
                            if mouseon then mouse_curs(on);
                   end;
                   'P':begin  {***  Play game  ***}
                            selectsound;
                            draw_button(2,1);
                            del:=2;
                            repeat until del=0;
                            if mouseon then mouse_curs(off);
                            buffer:=false;
                            game;
                            if not boss then
                            begin
                                 buffer_write('',false);
                                 buffer:=true;
                                 clear_playing_field;
                                 draw_mainscreen(false,true);
                            end;
                            if mouseon then mouse_curs(on);
                   end;
                   'Q':begin  {***  Quit Wiggly Worm '94 and return to DOS  ***}
                            selectsound;
                            draw_button(3,1);
                            repeat until qpos>qlen;
                            del:=4;
                            repeat until del=0;
                            exiton:=true;
                   end;
                   '?','/':begin  {***  Display help  ***}
                                selectsound;
                                draw_button(4,1);
                                del:=2;
                                repeat until del=0;
                                draw_button(4,2);
                                if mouseon then mouse_curs(off);
                                help;
                                if not boss then draw_mainscreen(false,false);
                                if mouseon then mouse_curs(on);
                   end;
                end;
                if mouseon then repeat until get_mousebutt=0;
           end;
     until exiton or boss;
     if mouseon then mouse_curs(off);
     if boss then endmessage:=false;
     closedown;
end;

begin
     flush_buffers;
     checkbreak:=false;
     nosound;
     randomize;
     if searchparam('/?') or searchparam('?') or searchparam('/H') then
     begin
          textcolor(lightcyan);
          writeln('Wiggly Worm ''94 Special Edition by J.P.Boggis '+verdate);
          textcolor(cyan);
          writeln('');
          textcolor(white);
          writeln('USAGE: WORM94SE [/Q] [/B] [/?]');
          textcolor(lightgray);
          writeln;
          writeln('/? - Displays this help screen.');
          writeln('/Q - Loads Wiggly Worm ''94 SE with sound turned off.');
          writeln('/B - Prevents "You have been playing..." message from being displayed when you');
          writeln('     exit to DOS.');
          writeln;
          writeln('     Note:  No message will be displayed if you use the emergency exit (F10).');
          writeln;
          writeln;
          writeln('Have fun...');
     end else
     begin
          fonts;
          if init_gfx then main else
             writeln(#7,'FATAL:  Wiggly Worm ''94 requires VGA 640x480 or better graphics.');
     end;
     nosound;
end.